# ImageContrastAdjustment
A Julia package for enhancing and manipulating image contrast.  

[![Build Status](https://travis-ci.com/JuliaImages/ImageContrastAdjustment.jl.svg?branch=master)](https://travis-ci.com/JuliaImages/ImageContrastAdjustment.jl)
[![Codecov](https://codecov.io/gh/JuliaImages/ImageContrastAdjustment.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaImages/ImageContrastAdjustment.jl)
[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliaimages.org/ImageContrastAdjustment.jl/stable)
[![](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliaimages.org/ImageContrastAdjustment.jl/dev)
[![PkgEval][pkgeval-img]][pkgeval-url]

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/I/ImageContrastAdjustment.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/report.html

module ImageContrastAdjustment

using ImageCore
using ImageBase
using ImageTransformations: imresize
# Where possible we avoid a direct dependency to reduce the number of [compat] bounds
using ImageCore.MappedArrays
using Parameters: @with_kw # Same as Base.@kwdef but works on Julia 1.0

# TODO Relax this to all image color types
const GenericGrayImage = AbstractArray{<:Union{Number, AbstractGray}}

@inline intensity(x::AbstractGray) = float(gray(x))
@inline intensity(x::Real) = float(x)

# TODO: port HistogramAdjustmentAPI to ImagesAPI
include("HistogramAdjustmentAPI/HistogramAdjustmentAPI.jl")
import .HistogramAdjustmentAPI: AbstractHistogramAdjustmentAlgorithm,
                                adjust_histogram, adjust_histogram!


include("build_histogram.jl")
include("algorithms/common.jl")
include("algorithms/adaptive_equalization.jl")
include("algorithms/equalization.jl")
include("algorithms/linear_stretching.jl")
include("algorithms/contrast_stretching.jl")
include("algorithms/gamma_correction.jl")
include("algorithms/matching.jl")
include("algorithms/midway_equalization.jl")
include("compat.jl")

export
    # main types and functions
    AdaptiveEqualization,
    Equalization,
    MidwayEqualization,
    Matching,
    GammaCorrection,
    LinearStretching,
    ContrastStretching,
    build_histogram,
    adjust_histogram,
    adjust_histogram!

end # module

# Usage:
#     julia benchmark/run_benchmarks.jl
using BenchmarkTools
using ImageContrastAdjustment
using ImageTransformations
using TestImages
using ImageCore

on_CI = haskey(ENV, "GITHUB_ACTIONS")

img = testimage("mandril_gray")
tst_sizes = on_CI ? (64, ) : (64, 128)
tst_types = (N0f8, Float32, Gray{N0f8}, Gray{Float32}, RGB{N0f8}, RGB{Float32})

const SUITE = BenchmarkGroup()

# TODO: add MidwayEqualization
alg_list = (( "LinearStretching", LinearStretching()),
            ( "AdaptiveEqualization", AdaptiveEqualization()),
            ( "ContrastStretching", ContrastStretching()),
            ( "Equalization", Equalization()),
            ( "GammaCorrection", GammaCorrection()),
            ( "Matching", Matching))


function add_algorithm_benchmark!(suite, img, alg_name, alg;
                                  tst_sizes, tst_types)
    haskey(suite, alg_name) || (suite[alg_name] = BenchmarkGroup())

    for T in tst_types
        haskey(suite[alg_name], T) || (suite[alg_name][T] = BenchmarkGroup())
        for sz in tst_sizes
            tst_img = imresize(T.(img), (sz, sz))
            if alg === Matching
                tst_alg = alg(targetimg = tst_img)
            else
                tst_alg = alg
            end
            
            suite[alg_name][T]["$sz×$sz"] = @benchmarkable adjust_histogram($tst_img, $tst_alg)
        end
    end
end


for (alg_name, alg) in alg_list
    add_algorithm_benchmark!(SUITE, img, alg_name, alg;
                             tst_sizes=tst_sizes,
                             tst_types=tst_types)
end

"""
```
    LinearStretching <: AbstractHistogramAdjustmentAlgorithm
    LinearStretching(; [src_minval], [src_maxval],
                       dst_minval=0, dst_maxval=1,
                       no_clamp=false)

    LinearStretching((src_minval, src_maxval) => (dst_minval, dst_maxval))
    LinearStretching((src_minval, src_maxval) => nothing)
    LinearStretching(nothing => (dst_minval, dst_maxval))

    adjust_histogram([T,] img, f::LinearStretching)
    adjust_histogram!([out,] img, f::LinearStretching)
```

Returns an image where the range of the intensities spans the interval [`dst_minval`, `dst_maxval`].

# Details


Linear stretching (also called *normalization*) is a contrast enhancing
transformation that is used to modify the dynamic range of the image. In
particular, suppose that the input image has gray values in the range [A,B] and
one wishes to change the dynamic range to [a,b] using a linear mapping, then the
necessary transformation is given by the relation

```math
f(x) = (x-A) \\frac{b-a}{B-A} + a.
```

# Options

Various options for the parameters of the `adjust_histogram` and
`LinearStretching` type  are described in more detail below.

## Choices for `img`

The function can handle a variety of input types. The returned
image depends on the input type.

For colored images, the input is converted to the
[YIQ](https://en.wikipedia.org/wiki/YIQ)  type and the intensities of the Y
channel are stretched to the specified range. The modified Y channel is then
combined with the I and Q channels and the resulting image converted to the same
type as the input.

## Choices for `dst_minval` and `dst_maxval`

If destination value range `dst_minval` and `dst_maxval` are specified then intensities are
mapped to the range [`dst_minval`, `dst_maxval`]. The default values are 0 and 1.

## Choices for `src_minval` and `src_maxval`

The source value range `src_minval` and `src_maxval` specifies the intensity range of input
image. By default, the values are `extrema(img)` (finite). If custom values are provided,
the output intensity value will be clamped to range `[dst_minval, dst_maxval]` if it exceeds that.

## `no_clamp`

Setting `no_clamp=true` to disable the automatic clamp even if the output intensity value
exceeds the range `[dst_minval, dst_maxval]`. Note that a clamp is still applied for types
that has limited value range, for example, if the input eltype is `N0f8`, then the output will
be clamped to `[0.0N0f8, 1.0N0f8]` even if `no_clamp==true`.

# Example

```julia
using ImageContrastAdjustment, TestImages

img = testimage("mandril_gray")
# Stretches the contrast in `img` so that it spans the unit interval.
imgo = adjust_histogram(img, LinearStretching(dst_minval = 0, dst_maxval = 1))
```

For convenience, Constructing a `LinearStretching` object using `Pair` is also supported

```julia
# these two constructors are equivalent
LinearStretching(src_minval=0.1, src_maxval=0.9, dst_minval=0.05, dst_maxval=0.95)
LinearStretching((0.1, 0.9) => (0.05, 0.95))

# replace the part with `nothing` to use default values, e.g.,
# specify only destination value range
LinearStretching(nothing => (0.05, 0.95))
# specify only source value range and use default destination value range, i.e., (0, 1)
LinearStretching((0.1, 0.9) => nothing)
```

# References
1. W. Burger and M. J. Burge. *Digital Image Processing*. Texts in Computer Science, 2016. [doi:10.1007/978-1-4471-6684-9](https://doi.org/10.1007/978-1-4471-6684-9)

"""
@with_kw struct LinearStretching{T} <: AbstractHistogramAdjustmentAlgorithm
    src_minval::T = nothing
    src_maxval::T = nothing
    dst_minval::T = 0.0f0
    dst_maxval::T = 1.0f0
    minval::T = nothing
    maxval::T = nothing
    no_clamp::Bool = false
    function LinearStretching(src_minval::T1,
                              src_maxval::T2,
                              dst_minval::T3,
                              dst_maxval::T4,
                              minval::T5=nothing,
                              maxval::T6=nothing,
                              no_clamp::Bool=false) where {T1 <: Union{Nothing,Real,AbstractGray},
                                                 T2 <: Union{Nothing,Real,AbstractGray},
                                                 T3 <: Union{Nothing,Real,AbstractGray},
                                                 T4 <: Union{Nothing,Real,AbstractGray},
                                                 T5 <: Union{Nothing,Real,AbstractGray},
                                                 T6 <: Union{Nothing,Real,AbstractGray}}
        # in order to deprecate old fields we have to introduce new fields if we still want to use @with_kw
        # https://github.com/JuliaImages/ImageContrastAdjustment.jl/pull/28#discussion_r395751301
        if !isnothing(minval)
            dst_minval = minval
            Base.depwarn("deprecated: use `dst_minval` for keyword `minval`", :LinearStretching)
        end
        if !isnothing(maxval)
            dst_maxval = maxval
            Base.depwarn("deprecated: use `dst_maxval` for keyword `maxval`", :LinearStretching)
        end

        dst_minval <= dst_maxval || throw(ArgumentError("dst_minval $dst_minval should be less than dst_maxval $dst_maxval"))
        if !(isnothing(src_minval) || isnothing(src_maxval))
            src_minval <= src_maxval || throw(ArgumentError("src_minval $src_minval should be less than src_maxval $src_maxval"))
        end
        T = promote_type(T1, T2, T3, T4, T5, T6)
        new{T}(convert(T, src_minval), convert(T, src_maxval),
               convert(T, dst_minval), convert(T, dst_maxval),
               convert(T, dst_minval), convert(T, dst_maxval),
               no_clamp)
    end
end
function LinearStretching(rangemap::Pair{Tuple{T1, T2}, Tuple{T3, T4}}; no_clamp=false) where {T1, T2, T3, T4}
    LinearStretching(rangemap.first..., rangemap.second..., nothing, nothing, no_clamp)
end
function LinearStretching(rangemap::Pair{Nothing, Tuple{T3, T4}}; no_clamp=false) where {T3, T4}
    LinearStretching(nothing, nothing, rangemap.second..., nothing, nothing, no_clamp)
end
function LinearStretching(rangemap::Pair{Tuple{T1, T2}, Nothing}; no_clamp=false) where {T1, T2}
    LinearStretching(src_minval=rangemap.first[1], src_maxval=rangemap.first[2], no_clamp=no_clamp)
end

function (f::LinearStretching)(out::GenericGrayImage, img::GenericGrayImage)
    T = eltype(out)
    FT = eltype(floattype(T))
    img_min, img_max = minimum_finite(img), maximum_finite(img)
    # explicit annotation is needed because the ?: line mixes three value types:
    # Nothing, T, and typeof(f.src_minval)
    src_minval::FT = isnothing(f.src_minval) ? img_min : f.src_minval
    src_maxval::FT = isnothing(f.src_maxval) ? img_max : f.src_maxval
    dst_minval::FT = f.dst_minval
    dst_maxval::FT = f.dst_maxval

    # the kernel operation `r * x - o` is equivalent to `(x-A) * ((b-a)/(B-A)) + a`
    # precalculate these and make inner loop contains only multiplication and addition
    # to get better performance
    r = (dst_maxval - dst_minval) / (src_maxval - src_minval)
    o = (src_minval*dst_maxval - src_maxval*dst_minval) / (src_maxval - src_minval)

    if 1 ≈ r && 0 ≈ o
        # when image intensity is already adjusted, there's no need to do it again
        # it's a trivial but common case in practice
        out === img || (out .= img)
        return out
    end

    # In most cases, we don't need to clamp the output
    # this is only used when user specifies custom parameters
    out_minval = r * img_min - o
    out_maxval = r * img_max - o
    do_clamp = f.no_clamp ? false : (out_minval < dst_minval) || (out_maxval > dst_maxval)
    # re-adjust clamp option to avoid ArgumentError
    if !do_clamp && (out_minval < typemin(T) || out_maxval > typemax(T))
        do_clamp = true
        dst_minval = convert(typeof(dst_minval), typemin(eltype(T)))
        dst_maxval = convert(typeof(dst_maxval), typemax(eltype(T)))
    else
        do_clamp = do_clamp || out_minval < typemin(T) || out_maxval > typemax(T)
        dst_minval = max(dst_minval, convert(typeof(dst_minval), typemin(eltype(T))))
        dst_maxval = min(dst_maxval, convert(typeof(dst_maxval), typemax(eltype(T))))
    end

    # although slightly faster, clamp before linear stretching has some rounding issue, e.g,
    # it's likely to get results like -9.313226f-10, which can't be directly converted to N0f8
    # thus the line below is commented out and not used
    # do_clamp && (img = clamp.(img, src_minval, src_maxval))

    # tweak the performance of FixedPoint by fusing operations into one broadcast
    # for Float32 the fallback implementation is faster
    if eltype(T) <: FixedPoint
        # ?: is faster than if-else
        @. out = do_clamp ? clamp(r * img - o, dst_minval, dst_maxval) : r * img - o
        return out
    end

    # fallback implementation
    @inbounds @simd for p in eachindex(img)
        val = img[p]
        if isnan(val)
            out[p] = val
        else
            newval = r * val - o
            do_clamp && (newval = clamp(newval, dst_minval, dst_maxval))
            out[p] = T <: Integer ? round(Int, newval) : newval
        end
    end
    out
end

function (f::LinearStretching)(out::AbstractArray{<:Color3}, img::AbstractArray{<:Color3})
    T = eltype(out)
    yiq = convert.(YIQ, img)
    yiq_view = channelview(yiq)
    adjust_histogram!(view(yiq_view,1,:,:), f)
    out .= convert.(T, yiq)
end

(f::LinearStretching)(out::GenericGrayImage, img::AbstractArray{<:Color3}) =
    f(out, of_eltype(Gray, img))

"""
```
    Equalization <: AbstractHistogramAdjustmentAlgorithm
    Equalization(; nbins = 256, minval = 0, maxval = 1)

    adjust_histogram([T,] img, f::Equalization)
    adjust_histogram!([out,] img, f::Equalization)
```

Returns a histogram equalized image with a granularity of `nbins` number of bins.

# Details

Histogram equalization was initially conceived to  improve the contrast in a
single-channel grayscale image. The method transforms the
distribution of the intensities in an image so that they are as uniform as
possible [1]. The natural justification for uniformity
is that the image has better contrast  if the intensity levels of an image span
a wide range on the intensity scale. As it turns out, the necessary
transformation is a mapping based on the cumulative histogram.

One can consider an ``L``-bit single-channel ``I \\times J`` image with gray
values in the set ``\\{0,1,\\ldots,L-1 \\}``, as a collection of independent and
identically distributed random variables. Specifically, let the sample space
``\\Omega`` be the set of all ``IJ``-tuples ``\\omega
=(\\omega_{11},\\omega_{12},\\ldots,\\omega_{1J},\\omega_{21},\\omega_{22},\\ldots,\\omega_{2J},\\omega_{I1},\\omega_{I2},\\ldots,\\omega_{IJ})``,
where each ``\\omega_{ij} \\in \\{0,1,\\ldots, L-1 \\}``. Furthermore, impose a
probability measure on ``\\Omega`` such that the functions ``\\Omega \\ni
\\omega \\to \\omega_{ij} \\in \\{0,1,\\ldots,L-1\\}`` are independent and
identically distributed.

One can then regard an image as a matrix of random variables ``\\mathbf{G} =
[G_{i,j}(\\omega)]``, where each function ``G_{i,j}: \\Omega \\to \\mathbb{R}``
is defined by
```math
G_{i,j}(\\omega) = \\frac{\\omega_{ij}}{L-1},
```
and each ``G_{i,j}`` is distributed according to some unknown density ``f_{G}``.
While ``f_{G}`` is unknown, one can approximate it with a normalized histogram
of gray levels,

```math
\\hat{f}_{G}(v)= \\frac{n_v}{IJ},
```
where
```math
n_v = \\left | \\left\\{(i,j)\\, |\\,  G_{i,j}(\\omega)  = v \\right \\} \\right |
```
represents the number of times a gray level with intensity ``v`` occurs in
``\\mathbf{G}``. To transform the distribution of the intensities so that
they are as uniform as possible one needs to find a mapping ``T(\\cdot)`` such
that ``T(G_{i,j}) \\thicksim U ``. The required mapping turns out to be the
cumulative distribution function (CDF) of the empirical density
``\\hat{f}_{G}``,
```math
 T(G_{i,j}) = \\int_0^{G_{i,j}}\\hat{f}_{G}(w)\\mathrm{d} w.
```

# Options

Various options for the parameters of the `adjust_histogram` function and
`Equalization` type are described in more detail below.

## Choices for `img`

The `adjust_histogram` function can handle a variety of
input types.  By default type of the returned image matches the input type.

For colored images, the input is converted to
[YIQ](https://en.wikipedia.org/wiki/YIQ) type and the Y channel is equalized.
This is the combined with the I and Q channels and the resulting image converted
to the same type as the input.

## Choices for `nbins` in `Equalization`

You can specify the total number of bins in the histogram.

## Choices for `minval` and `maxval` in `Equalization`

If `minval` and `maxval` are specified then intensities are equalized to the range
[`minval`, `maxval`]. The default values are 0 and 1.

# Example

```julia

using TestImages, FileIO, ImageView

img =  testimage("mandril_gray")
imgeq = adjust_histogram(img, Equalization(nbins = 256, minval = 0, maxval = 1))

imshow(img)
imshow(imgeq)
```

# References
1. R. C. Gonzalez and R. E. Woods. *Digital Image Processing (3rd Edition)*.  Upper Saddle River, NJ, USA: Prentice-Hall,  2006.
"""
@with_kw struct Equalization{T₁ <: Union{Real,AbstractGray},
                                T₂ <: Union{Real,AbstractGray}} <: AbstractHistogramAdjustmentAlgorithm
    nbins::Int = 256
    minval::T₁ = 0.0
    maxval::T₂ = 1.0
end

function (f::Equalization)(out::GenericGrayImage, img::GenericGrayImage)
    minval, maxval = convert(eltype(out), f.minval), convert(eltype(out), f.maxval)
    edges, histogram = build_histogram(img, f.nbins, minval = minval, maxval = maxval)
    lb = first(axes(histogram,1))
    ub = last(axes(histogram,1))
    N = length(img)
    cdf = cumsum(histogram[lb:ub]/N)
    newvals = build_lookup(cdf, minval, maxval)
    transform_density!(out, img, edges, newvals)
end

function (f::Equalization)(out::AbstractArray{<:Color3}, img::AbstractArray{<:Color3})
    T = eltype(img)
    yiq = convert.(YIQ, img)
    yiq_view = channelview(yiq)
    adjust_histogram!(view(yiq_view,1,:,:), f)
    out .= convert.(T, yiq)
end

(f::Equalization)(out::GenericGrayImage, img::AbstractArray{<:Color3}) =
    f(out, of_eltype(Gray, img))

@testset "Gamma Correction" begin

    for T in (Gray{N0f8}, Gray{N0f16}, Gray{Float32}, Gray{Float64})
        img = fill(oneunit(T),10,10)
        ret = adjust_histogram(img, GammaCorrection(gamma = 1))
        @test img == ret
        @test eltype(ret) == eltype(img)

        imgp = padarray(img, Fill(zero(T), (2,2)))
        retp = adjust_histogram(imgp, GammaCorrection(gamma = 1))
        @test imgp == retp
        @test eltype(retp) == eltype(imgp)
    end
    # ERROR: MethodError: no method matching ^(::AGray{Normed{UInt8,8}}, ::Float64)
    img = fill(oneunit(AGray{N0f8}),10,10)
    @test_broken adjust_histogram(img, GammaCorrection(gamma = 0.5))

    # ERROR: MethodError: no method matching ^(::AGray{Normed{UInt8,8}}, ::Float64)
    img = fill(oneunit(ARGB{N0f8}),10,10)
    @test_broken adjust_histogram(img, GammaCorrection(gamma = 0.5))


    for T in (RGB{N0f8}, RGB{N0f16}, RGB{Float64})
        img = fill(oneunit(T),10,10)
        ret = adjust_histogram(img, GammaCorrection(gamma = 1))
        @test all(map((i, r) -> isapprox(i, r), img, ret))
        @test eltype(ret) == eltype(img)
        imgp = padarray(img, Fill(zero(T), (2,2)))
        retp = adjust_histogram(imgp, GammaCorrection(gamma = 1))
        @test all(map((i, r) -> isapprox(i, r), imgp, retp))
        @test eltype(retp) == eltype(imgp)
    end

    for T in (Gray{N0f8}, Gray{N0f16}, Gray{Float32}, Gray{Float64})
        img = T.(collect(reshape(1/100:1/100:1, 10, 10)))
        for i = 0.5:0.27:2
            ret = adjust_histogram(img, GammaCorrection(gamma = i))
            @test ret == T.(img .^ i)
        end
    end

    # Since the function returns the same output type as the input type
    # there is an implicit rounding operation when dealing with integer values.
    img = reshape(1:1:100, 10, 10)
    for i = 0.5:0.28:2
        ret = adjust_histogram(img, GammaCorrection(gamma = i))
        @test ret == round.(Int, img .^ i)
    end

end

@testset "Midway Histogram Equalization" begin
    for T in (Gray{N0f8}, Gray{N0f16}, Gray{Float32}, Gray{Float64})
        # Define two images consisting of luminance gradients with different
        # (non-overlapping) intensities. The "midway" equalization should produce
        # two new images for which the cummulative distribution function of the
        # image intensities is identical.
        img1 = T.(zeros(256,10))
        for i = 32:96
            for j = 1:10
                img1[i,j] = i/255.0
            end
        end
        img2 = T.(zeros(256,10))
        for i = 128:192
            for j = 1:10
                img2[i,j] = i/255.0
            end
        end
        img1o, img2o = adjust_histogram([img1, img2], MidwayEqualization(nbins = 256))
        edges1, counts1 = build_histogram(img1o, 256, minval = 0, maxval = 1)
        edges2, counts2 = build_histogram(img2o, 256, minval = 0, maxval = 1)
        @test sum(cumsum(counts2) - cumsum(counts1)) == 0

        edges, _ = build_histogram(img1, 256, minval = 0, maxval = 1)
        img1o, img2o = adjust_histogram([img1, img2], MidwayEqualization(edges = edges))
        edges1, counts1 = build_histogram(img1o, 256, minval = 0, maxval = 1)
        edges2, counts2 = build_histogram(img2o, 256, minval = 0, maxval = 1)
        @test sum(cumsum(counts2) - cumsum(counts1)) == 0

    end

    for T in (RGB{N0f8}, RGB{N0f16}, RGB{Float32}, RGB{Float64})
        imgg1 = zeros(Gray{Float32},256,10)
        for i = 32:96
            for j = 1:10
                imgg1[i,j] = i/255.0
            end
        end
        img1 = colorview(RGB,imgg1,imgg1,imgg1)
        img1 = T.(img1)

        imgg2 = zeros(Gray{Float32},256,10)
        for i = 128:192
            for j = 1:10
                imgg2[i,j] = i/255.0
            end
        end
        img2 = colorview(RGB,imgg2,imgg2,imgg2)
        img2 = T.(img2)

        img1o, img2o = ImageContrastAdjustment.adjust_histogram([img1, img2], ImageContrastAdjustment.MidwayEqualization(nbins = 256))

        edges1, counts1 = ImageContrastAdjustment.build_histogram(img1o, 256, minval = 0, maxval = 1)
        edges2, counts2 = ImageContrastAdjustment.build_histogram(img2o, 256, minval = 0, maxval = 1)
        # The algorithm equalizes the Y channels from the YIQ decomposition of the RGB images and then
        # constructs new RGB images by combining the equalised Y channels with the IQ components.
        # The build_histogram function then implicitly converts the "midway" RGB images to Gray
        # in order to construct the histogram. After this process the cummulative distribution functions
        # of these luminance gradients are no longer identical but still close.
        @test abs(sum(cumsum(counts2) - cumsum(counts1))) <= 20

        edges, _ = build_histogram(img1, 256, minval = 0, maxval = 1)
        img1o, img2o = adjust_histogram([img1, img2], MidwayEqualization(edges = edges))
        edges1, counts1 = build_histogram(img1o, 256, minval = 0, maxval = 1)
        edges2, counts2 = build_histogram(img2o, 256, minval = 0, maxval = 1)
        @test sum(cumsum(counts2) - cumsum(counts1)) <= 20
    end
end

function partition_interval(nbins::Integer, minval::Real, maxval::Real)
    return range(minval, step=(maxval - minval) / nbins, length=nbins)
end

function partition_interval(nbins::Integer, minval::AbstractGray, maxval::AbstractGray)
    return partition_interval(nbins, gray(minval), gray(maxval))
end

"""
    edges, counts = rebin(edges0, counts0, nbins, minval, maxval)

Re-bin a histogram (represented by `edges0` and `counts0`) to have `nbins` spanning
`minval` to `maxval`.
"""
function rebin(edges0, counts0, nbins, minval, maxval)
    edges = partition_interval(nbins, minval, maxval)
    counts = fill(0, 0:nbins)
    o = Base.Order.Forward
    for (i, e) in enumerate(edges0)
        index = searchsortedlast(edges, e, o)
        counts[index] += counts0[i]
    end
    counts[0] += counts0[0]
    return edges, counts
end

"""
```
edges, count = build_histogram(img)            # For 8-bit images only
edges, count = build_histogram(img, nbins)
edges, count = build_histogram(img, nbins; minval, maxval)
edges, count = build_histogram(img, edges)
```

Generates a histogram for the image over `nbins` spread between `[minval, maxval]`.
Color images are automatically converted to grayscale.

# Output
Returns `edges` which is a `AbstractRange` type that specifies how the  interval
`[minval, maxval]` is divided into bins, and an array `count` which records the
concomitant bin frequencies. In particular, `count` has the following
properties:

* `count[0]` is the number satisfying `x < edges[1]`
* `count[i]` is the number of values `x` that satisfy `edges[i] <= x < edges[i+1]`
* `count[end]` is the number satisfying `x >= edges[end]`.
* `length(count) == length(edges)+1`.

# Details

One can consider a histogram as a piecewise-constant model of a probability
density function ``f`` [1]. Suppose that ``f`` has support on some interval ``I =
[a,b]``.  Let ``m`` be an integer and ``a = a_1 < a_2 < \\ldots < a_m < a_{m+1} =
b`` a sequence of real numbers. Construct a sequence of intervals

```math
I_1 = [a_1,a_2], I_2 = (a_2, a_3], \\ldots, I_{m} = (a_m,a_{m+1}]
```

which partition ``I`` into subsets ``I_j`` ``(j = 1, \\ldots, m)`` on which
``f`` is constant. These subsets satisfy ``I_i \\cap I_j = \\emptyset, \\forall
i \\neq j``, and are commonly referred to as *bins*. Together they encompass the
entire range of data values such that ``\\sum_j |I_j | = | I |``. Each bin has
width ``w_j = |I_j| = a_{j+1} - a_j`` and height ``h_j`` which is the constant
probability density over the region of the bin. Integrating the constant
probability density over the width of the bin ``w_j`` yields a probability mass
of ``\\pi_j = h_j w_j`` for the bin.

For a sample ``x_1, x_2, \\ldots, x_N``, let


```math
n_j = \\sum_{n = 1}^{N}\\mathbf{1}_{(I_j)}(x_n),
\\quad \\text{where} \\quad
\\mathbf{1}_{(I_j)}(x) =
\\begin{cases}
 1 & \\text{if} \\; x \\in I_j,\\\\
 0 & \\text{otherwise},
\\end{cases},
```
represent the number of samples falling into the interval ``I_j``. An estimate
for the probability mass of the ``j``th bin is given by the relative frequency
``\\hat{\\pi} = \\frac{n_j}{N}``, and the histogram estimator of the probability
density function is defined as
```math
\\begin{aligned}
\\hat{f}_n(x)  & = \\sum_{j = 1}^{m}\\frac{n_j}{Nw_j} \\mathbf{1}_{(I_j)}(x) \\\\
& = \\sum_{j = 1}^{m}\\frac{\\hat{\\pi}_j}{w_j} \\mathbf{1}_{(I_j)}(x) \\\\
& = \\sum_{j = 1}^{m}\\hat{h}_j \\mathbf{1}_{(I_j)}(x).
\\end{aligned}
```

The function ``\\hat{f}_n(x)`` is a genuine density estimator because ``\\hat{f}_n(x)  \\ge 0`` and
```math
\\begin{aligned}
\\int_{-\\infty}^{\\infty}\\hat{f}_n(x) \\operatorname{d}x & = \\sum_{j=1}^{m} \\frac{n_j}{Nw_j} w_j \\\\
& = 1.
\\end{aligned}
```

# Options
Various options for the parameters of this function are described in more detail
below.

## Choices for `nbins`
You can specify the number of discrete bins for the histogram. When specifying
the number of bins consider the maximum number of graylevels that your image
type supports. For example, with an image of type `N0f8` there is a maximum
of 256 possible graylevels. Hence, if you request more than 256 bins for
that type of image you should expect to obtain zero counts for numerous bins.


## Choices for `minval`
You have the option to specify the lower bound of the interval over which the
histogram will be computed.  If `minval` is not specified then the minimum
value present in the image is taken as the lower bound.

## Choices for `maxval`
You have the option to specify the upper bound of the interval over which the
histogram will be computed.  If `maxval` is not specified then the maximum
value present in the image is taken as the upper bound.

## Choices for `edges`
If you do not designate the number of bins, nor the lower or upper bound of the
interval, then you have the option to directly stipulate how the intervals will
be divided by specifying a `AbstractRange` type.

# Example

Compute the histogram of a grayscale image.
```julia

using TestImages, FileIO, ImageView

img =  testimage("mandril_gray");
edges, counts  = build_histogram(img, 256, minval = 0, maxval = 1)
```

Given a color image, compute the histogram of the red channel.
```julia
img = testimage("mandrill")
r = red.(img)
edges, counts  = build_histogram(r, 256, minval = 0, maxval = 1)
```

# References
[1] E. Herrholz, "Parsimonious Histograms," Ph.D. dissertation, Inst. of Math. and Comp. Sci., University of Greifswald, Greifswald, Germany, 2011.
"""
function build_histogram(img::GenericGrayImage, nbins::Integer = 256;
                         minval::Union{Real,AbstractGray}=minimum_finite(img),
                         maxval::Union{Real,AbstractGray}=maximum_finite(img))
    edges = partition_interval(nbins, minval, maxval)
    build_histogram(img, edges)
end

function build_histogram(img::AbstractArray{C}, nbins::Integer = 256; kwargs...) where C<:Color
    build_histogram(mappedarray(Gray{eltype(C)}, img), nbins; kwargs...)
end

# Performance optimizations for build_histogram(img, nbins)

function build_histogram(img::AbstractArray{T}) where T<:Union{N0f8, AbstractGray{N0f8}}
    edges = range(N0f8(0), step=eps(N0f8), length=256)
    counts = fill(0, 0:256)
    @simd for v in img
        @inbounds counts[reinterpret(gray(v))+1] += 1
    end
    return edges, counts
end

build_histogram(img::AbstractArray{C}) where C<:Color{N0f8} =
    build_histogram(mappedarray(Gray{N0f8}, img))

function build_histogram(img::AbstractArray{T}, nbins::Integer;
                         minval::Union{Real,AbstractGray}=minimum_finite(img),
                         maxval::Union{Real,AbstractGray}=maximum_finite(img))  where T<:Union{N0f8, AbstractGray{N0f8}}
    edgesraw, countsraw = build_histogram(img)
    return rebin(edgesraw, countsraw, nbins, minval, maxval)
end

# build_histogram(img, edges)

function build_histogram(img::AbstractArray{C}, edges::AbstractRange) where C<:Color
    build_histogram(mappedarray(Gray{eltype(C)}, img), edges)
end

function build_histogram(img::GenericGrayImage, edges::AbstractRange)
    Base.has_offset_axes(edges) && throw(ArgumentError("edges must be indexed starting with 1"))
    lb = first(axes(edges,1))-1
    ub = last(axes(edges,1))
    first_edge, last_edge = first(edges), last(edges)
    inv_step_size = 1/step(edges)
    counts = fill(0, lb:ub)
    @inbounds for val in img
         if isnan(val)
             continue
         else
            if val >= last_edge
                counts[ub] += 1
            elseif val < first_edge
                counts[lb] += 1
            else
                index = floor(Int, intensity((val-first_edge)*inv_step_size)) + 1
                counts[index] += 1
            end
        end
    end
    edges, counts
end

@testset "Histogram Matching" begin
    # Construct a target image by adjusting the gamma of a standard
    # test image. Then transform the distribution of the test image
    # so that the intensity distribution matches the gamma-adjusted target
    # image. With Float32 and Float64 types the distributions match
    # exactly. For N0f8 and N0f16 types there are some round-off errors and
    # some of the bins of the transformed distributions are shifted
    # by one bin when compared to the target distribution. Hence, we
    # omit N0f8 and N0f16 from this particular test.
    for T in (Gray{Float32}, Gray{Float64})
        img = T.(testimage("mandril_gray"))
        imgo = T.(adjust_histogram(img, GammaCorrection(gamma = 0.5)))

        result = adjust_histogram(img, Matching(targetimg = imgo, nbins = 256))

        edges_target, counts_target = build_histogram(imgo, 256, minval = 0, maxval = 1)
        edges_result, counts_result = build_histogram(result, 256, minval = 0, maxval = 1)
        @test all(counts_target .== counts_result)

        # Check that we get the same result if we explicitly pass the
        # bin edges.
        edges, _ = build_histogram(img,256, minval = 0, maxval = 1)
        result = adjust_histogram(img, Matching(targetimg = imgo, edges = edges))

        edges_target, counts_target = build_histogram(imgo, 256,minval = 0, maxval = 1)
        edges_result, counts_result = build_histogram(result, 256, minval = 0, maxval = 1)
        @test all(counts_target .== counts_result)
    end

    for T in (Gray{N0f8}, Gray{N0f16}, Gray{Float16}, Gray{Float32})
        img = T.([i < 64 ? i/255 : 0 for i = 0:255])
        imgo = T.([i > 64 && i < 128 ? i/255 : 0 for i = 0:255])
        result = adjust_histogram(img, Matching(targetimg = imgo, nbins = 256))
        edges_source, counts_source = build_histogram(img, 256, minval = 0, maxval = 1)
        edges_target, counts_target = build_histogram(imgo,256, minval = 0, maxval = 1)
        edges_result, counts_result = build_histogram(result,256, minval = 0, maxval = 1)
        @test all(counts_target .== counts_result)
    end

    for T in (RGB{N0f8}, RGB{N0f16}, RGB{Float32}, RGB{Float64})
        imgg = Gray{N0f8}.([i < 64 ? i/255 : 0 for i = 0:255])
        img =  T.(imgg,imgg,imgg)
        imggo = Gray{N0f8}.([i > 64 && i < 128 ? i/255 : 0 for i = 0:255])
        imgo = T.(imggo,imggo,imggo)
        result = adjust_histogram(img, Matching(targetimg = imgo, nbins = 256))
        edges_source, counts_source = build_histogram(img, 256, minval = 0, maxval = 1)
        edges_target, counts_target = build_histogram(imgo, 256, minval = 0, maxval = 1)
        edges_result, counts_result = build_histogram(result, 256, minval = 0, maxval = 1)
        @test all(counts_target .== counts_result)

        # Check that we get the same result if we explicitly pass the
        # bin edges.
        edges = 0.0:0.0019454658031463623:0.4960937798023224
        result = adjust_histogram(img, Matching(targetimg = imgo, edges = edges))
        edges_source, counts_source = build_histogram(img, 256, minval = 0, maxval = 1)
        edges_target, counts_target = build_histogram(imgo, 256, minval = 0, maxval = 1)
        edges_result, counts_result = build_histogram(result, 256, minval = 0, maxval = 1)
        @test all(counts_target .== counts_result)
    end

    # Modification of Tim's example:
    # https://github.com/JuliaImages/Images.jl/pull/752
    img = Gray.([0.4 0.45; 0.5 0.55])
    imgo = Gray.([0.1 0.3; 0.7 0.9])
    result = adjust_histogram(img, Matching(targetimg = imgo))
    edges_target, counts_target = build_histogram(imgo, 256, minval = 0, maxval = 1)
    edges_result, counts_result = build_histogram(result, 256, minval = 0, maxval = 1)
    @test all(counts_target .== counts_result)

    # Verify idempotency.
    img = collect(0:1:255)
    result = adjust_histogram(img, Matching(targetimg = img, nbins = 256))
    edges_target, counts_target = build_histogram(img, 256, minval = 0, maxval = 255)
    edges_result, counts_result = build_histogram(result, 256, minval = 0, maxval = 255)
    @test all(counts_target .== counts_result)

    # Verify that the algorithm works on integers.
    img = ([i <= 64 ? i : 0 for i = 0:255])
    imgo = ([i > 255-64 && i <= 255 ? i : 0 for i = 0:255])
    result = adjust_histogram(img, Matching(targetimg = imgo, nbins = 256))
    edges_source, counts_source = build_histogram(img, 256, minval = 0, maxval = 255)
    edges_target, counts_target = build_histogram(imgo, 256, minval = 0, maxval = 255)
    edges_result, counts_result = build_histogram(result, 256, minval = 0, maxval = 255)
    @test all(counts_target .== counts_result)

    # Verify that the algorithm can cope with NaN.
    img_nan =  Float64.(collect(0:1/255:1))
    img_nan[1:128] .= NaN
    reference_nan = adjust_histogram(img_nan, Matching(targetimg = img_nan))
    @test all(isapprox.(img_nan[129:end], reference_nan[129:end]; atol = 1e-1))
end

# To run it locally, BenchmarkCI should be added to root project
using BenchmarkCI
on_CI = haskey(ENV, "GITHUB_ACTIONS")

BenchmarkCI.judge()
on_CI ? BenchmarkCI.postjudge() : BenchmarkCI.displayjudgement()

using ImageContrastAdjustment
using Test, ImageCore, ImageFiltering, TestImages, LinearAlgebra, StableRNGs
using Aqua

if Base.VERSION >= v"1.6"
    @testset "Aqua" begin
        # TODO: fix the ambiguity test
        Aqua.test_all(ImageContrastAdjustment; ambiguities=false)
    end
end

@testset "ImageContrastAdjustment.jl" begin
    include("core.jl")
    include("adaptive_equalization.jl")
    include("histogram_construction.jl")
    include("histogram_matching.jl")
    include("histogram_equalization.jl")
    include("histogram_midway_equalization.jl")
    include("gamma_adjustment.jl")
    include("linear_stretching.jl")
    include("contrast_stretching.jl")
end

# usage example for package developer:
#
#     import HistogramAdjustmentAPI: AbstractHistogramAdjustmentAlgorithm,
#                             adjust_histogram, adjust_histogram!

"""
    AbstractHistogramAdjustmentAlgorithm <: AbstractImageFilter

The root type for `ImageContrastAdjustment` package.

Any concrete histogram adjustment algorithm shall subtype it to support
[`adjust_histogram`](@ref) and [`adjust_histogram!`](@ref) APIs.

# Examples

All histogram adjustment algorithms in ImageContrastAdjustment are called in the
following pattern:

```julia
# first generate an algorithm instance
f = LinearStretching()

# then pass the algorithm to `adjust_histogram`
img_adjusted = adjust_histogram(img, f)

# or use in-place version `adjust_histogram!`
img_adjusted = similar(img)
adjust_histogram!(img_adjusted, img, f)
```

Some algorithms also receive additional information as an argument,
e.g., `nbins` of `Equalization`.

```julia
# you can explicit specify the parameters
f = Equalization(nbins = 32)
```

For more examples, please check [`adjust_histogram`](@ref),
[`adjust_histogram!`](@ref) and concrete algorithms.
"""
abstract type AbstractHistogramAdjustmentAlgorithm <: AbstractImageFilter end

adjust_histogram!(out::Union{GenericGrayImage, AbstractArray{<:Color3}},
          img,
          f::AbstractHistogramAdjustmentAlgorithm,
          args...; kwargs...) =
    f(out, img, args...; kwargs...)

# TODO: Relax this to all color types
function adjust_histogram!(img::Union{GenericGrayImage, AbstractArray{<:Color3}},
                   f::AbstractHistogramAdjustmentAlgorithm,
                   args...; kwargs...)
    tmp = copy(img)
    f(img, tmp, args...; kwargs...)
    return img
end

function adjust_histogram(::Type{T},
                  img,
                  f::AbstractHistogramAdjustmentAlgorithm,
                  args...; kwargs...) where T
    out = similar(Array{T}, axes(img))
    adjust_histogram!(out, img, f, args...; kwargs...)
    return out
end

adjust_histogram(img::AbstractArray{T},
                 f::AbstractHistogramAdjustmentAlgorithm,
                 args...; kwargs...) where T <: Colorant =
         adjust_histogram(T, img, f, args...; kwargs...)

# Do not promote Number to Gray{<:Number}
adjust_histogram(img::AbstractArray{T},
                 f::AbstractHistogramAdjustmentAlgorithm,
                 args...; kwargs...) where T <: Number =
        adjust_histogram(T, img, f, args...; kwargs...)


# Handle instance where the input is a sequence of images.
adjust_histogram!(out_sequence::Vector{T},
          img_sequence,
          f::AbstractHistogramAdjustmentAlgorithm,
          args...; kwargs...) where T <: Union{GenericGrayImage, AbstractArray{<:Color3}} =
    f(out_sequence, img_sequence, args...; kwargs...)

# TODO: Relax this to all color types
function adjust_histogram!(img_sequence::Vector{T},
                   f::AbstractHistogramAdjustmentAlgorithm,
                   args...; kwargs...) where T <: Union{GenericGrayImage, AbstractArray{<:Color3}}
    tmp = copy(img_sequence)
    f(img_sequence, tmp, args...; kwargs...)
    return img_sequence
end

function adjust_histogram(::Type{T},
                  img_sequence::Vector{<:AbstractArray},
                  f::AbstractHistogramAdjustmentAlgorithm,
                  args...; kwargs...) where T
    N  = length(img_sequence)
    out_sequence = [similar(Array{T}, axes(img_sequence[n])) for n = 1:N]
    adjust_histogram!(out_sequence, img_sequence, f, args...; kwargs...)
    return out_sequence
end

adjust_histogram(img_sequence::Vector{<:AbstractArray{T}},
                 f::AbstractHistogramAdjustmentAlgorithm,
                 args...; kwargs...) where T <: Colorant =
         adjust_histogram(T, img_sequence, f, args...; kwargs...)

# Do not promote Number to Gray{<:Number}
adjust_histogram(img_sequence::Vector{<:AbstractArray{T}},
                 f::AbstractHistogramAdjustmentAlgorithm,
                 args...; kwargs...) where T <: Number =
        adjust_histogram(T, img_sequence, f, args...; kwargs...)

### Docstrings

"""
    adjust_histogram!([out,] img, f::AbstractHistogramAdjustmentAlgorithm, args...; kwargs...)

Adjust histogram of `img` using algorithm `f`.

# Output

If `out` is specified, it will be changed in place. Otherwise `img` will be changed in place.

# Examples

Just simply pass an algorithm to `adjust_histogram!`:

```julia
img_adjusted = similar(img)
adjust_histogram!(img_adjusted, img, f)
```

For cases you just want to change `img` in place, you don't necessarily need to manually
allocate `img_adjusted`; just use the convenient method:

```julia
adjust_histogram!(img, f)
```

See also: [`adjust_histogram`](@ref)
"""
adjust_histogram!

"""
    adjust_histogram([T::Type,] img, f::AbstractHistogramAdjustmentAlgorithm, args...; kwargs...)

Adjust histogram of `img` using algorithm `f`.

# Output

The return image `img_adjusted` is an `Array{T}`.

If `T` is not specified, then it's inferred.
# Examples

Just simply pass the input image and algorithm to `adjust_histogram`

```julia
img_adjusted = adjust_histogram(img, f)
```

This reads as "`adjust_histogram` of image `img` using algorithm `f`".

You can also explicitly specify the return type:

```julia
img_adjusted_float32 = adjust_histogram(Gray{Float32}, img, f)
```

See also [`adjust_histogram!`](@ref) for in-place histogram adjustment.
"""
adjust_histogram

@testset "Core" begin
        A = [NaN 1 2 3;
             NaN 6 5 4]
        @test ImageContrastAdjustment.minimum_finite(A) == 1
        @test ImageContrastAdjustment.maximum_finite(A) == 6
        A = rand(10:20, 5, 5)
        @test ImageContrastAdjustment.minimum_finite(A) == minimum(A)
        @test ImageContrastAdjustment.maximum_finite(A) == maximum(A)
        A = reinterpret(N0f8, rand(0x00:0xff, 5, 5))
        @test ImageContrastAdjustment.minimum_finite(A) == minimum(A)
        @test ImageContrastAdjustment.maximum_finite(A) == maximum(A)
        A = rand(Float32,3,5,5)
        img = colorview(RGB, A)
        dc = ImageContrastAdjustment.minimum_finite(img)-RGB{Float32}(minimum(A, dims=(2,3))...)
        @test norm(dc) < 1e-6
        dc = ImageContrastAdjustment.maximum_finite(img)-RGB{Float32}(maximum(A, dims=(2,3))...)
        @test norm(dc) < 1e-6
        @test ImageContrastAdjustment.minimum_finite(x->x^2,[NaN,10,2]) == 4
        @test ImageContrastAdjustment.maximum_finite(x->x^2,[NaN,10,2]) == 100
end

function transform_density!(out::GenericGrayImage, img::GenericGrayImage, edges::AbstractRange, newvals::AbstractVector)
    first_edge, last_edge = first(edges), last(edges)
    first_newval, last_newval = first(newvals), last(newvals)
    inv_step_size = 1/step(edges)
    function transform(val)
        val = intensity(val)
        if val >= last_edge
            return last_newval
        elseif val < first_edge
            return first_newval
        else
            index = floor(Int, (val-first_edge)*inv_step_size) + 1
            @inbounds newval = newvals[index]
            return newval
        end
    end
    map!(transform, out, img)
end

function transform_density!(out::GenericGrayImage, img::GenericGrayImage{T}, edges::AbstractRange, newvals::AbstractVector) where T<:Union{N0f8,AbstractGray{N0f8}}
    # When dealing with 8-bit images, we can improve computational performance by precomputing the lookup table
    # for how the intensities transform (there are only 256 calculations of intensities rather than `length(img)`
    # calculations of intensities).
    lookup = Vector{eltype(newvals)}(undef, 256)
    invoke(transform_density!, Tuple{GenericGrayImage,GenericGrayImage,AbstractRange,AbstractVector},
                               lookup, zero(T):eps(T):oneunit(T), edges, newvals)
    map!(out, img) do val
        lookup[uint8val(val)+1]
    end
end

uint8val(x::N0f8) = reinterpret(x)
uint8val(x::AbstractGray) = uint8val(gray(x))

function build_lookup(cdf, minval::T, maxval::T) where T
    first_cdf = first(cdf)
    # Scale the new intensity value to so that it lies in the range [minval, maxval].
    scale = (maxval - minval) / (cdf[end] - first_cdf)
    if T <: Integer
        return T[ceil(minval + (x - first_cdf) * scale) for x in cdf]
    end
    return T[minval + (x - first_cdf) * scale for x in cdf]
end

function construct_pdfs(img::GenericGrayImage, targetimg::AbstractArray, edges::AbstractRange)
    _, histogram = build_histogram(img, edges)
    _, target_histogram = build_histogram(targetimg, edges)
    return edges, histogram / sum(histogram), target_histogram / sum(target_histogram)
end

function construct_pdfs(img::GenericGrayImage, targetimg::AbstractArray, nbins::Integer = 256)
    if eltype(img) <: AbstractGray
        imin, imax = 0, 1
    else
        imin, imax = min(minimum_finite(img), minimum_finite(targetimg)), max(maximum_finite(img), maximum_finite(targetimg))
    end
    edges, histogram = build_histogram(img, nbins, minval = imin, maxval = imax)
    _, target_histogram = build_histogram(targetimg, edges)
    return edges, histogram / sum(histogram), target_histogram / sum(target_histogram)
end

function lookup_icdf(cdf::AbstractArray, targetcdf::AbstractArray)
    lookup_table = zeros(Int, length(cdf))
    i = 1
    for j = 1:length(cdf)
        p = cdf[j]
        while i < length(targetcdf) && targetcdf[i+1] <= p
            i += 1
        end
        lookup_table[j] = i
    end
    lookup_table
end

function cdf2pdf!(pdf::AbstractArray, cdf::AbstractArray)
    pdf[1] = cdf[1]
    for i = length(cdf)-1:-1:2
        pdf[i] = cdf[i] - cdf[i-1]
    end
end

"""
```
    MidwayEqualization <: AbstractHistogramAdjustmentAlgorithm
    MidwayEqualization(; nbins = 256, minval = 0, maxval = 1)

    adjust_histogram([T,] img_sequence, f::MidwayEqualization(nbins = 256, edges = nothing))
    adjust_histogram!([out_sequence,] img_sequence, f::MidwayEqualization(nbins = 256, edges = nothing))
```

Gives a pair of images the same histogram whilst maintaining as
much as possible their previous grey level dynamics.

# Details

The purpose of midway histogram equalization is to transform the intensities in
a pair of images so that the intensities distribute according to a common
"midway" distribution. The histogram representing the common distribution is
chosen so that the original  gray level dynamics of the images are preserved as
much as possible. If one interprets histograms as piecewise-constant models of
probability density functions (see [`build_histogram`](@ref
build_histogram(::AbstractArray, ::Integer, ::Union{Real,AbstractGray},
::Union{Real,AbstractGray}))), then the midway histogram equalization task can
be modeled as the problem of transforming one probability distribution into
another (see [`adjust_histogram`](@ref adjust_histogram(::Matching,::AbstractArray, ::AbstractArray, ::Integer))).
It turns out that the solution to this transformation problem involves the
cumulative and inverse cumulative distribution functions of the source and
"midway" probability density functions. In particular, let the random variables ``X_i \\thicksim p_{x_i} \\; (i = 1,2)``,
and ``Z \\thicksim p_{z}``  represent an intensity in the first, second and
"midway" image respectively, and let

```math
 S_{X_i}(x) = \\int_0^{x}p_{x_i}(w)\\mathrm{d} w \\; \\quad \\text{and} \\quad
 T_{Z}(x) = \\frac{2}{\\frac{1}{S_{X_1}(x)} + \\frac{1}{S_{X_2}(x)}}
```
represent the cumulative distribution functions of the two input images, and
their *harmonic mean*, respectively. Then the sought-after mapping
``Q_{X_i}(\\cdot)`` ``(i = 1,2)`` such that ``Q_{X_i}(x) \\thicksim p_{z} `` is
given by

```math
Q_{X_i}(x) =  T_{Z}^{-1}\\left( S_{X_i}(x) \\right),
```

where ``T_{Z}^{-1}(y) = \\operatorname{min} \\{ x \\in \\mathbb{R} : y \\leq
T_{Z}(x) \\}`` is the inverse cumulative distribution function of ``T_{Z}(x)``.


# Options

Various options for the parameters of the `adjust_histogram` function and
`MidwayEqualization` types are described in more detail below.

## Choices for `img_sequence`

The function `adjust_histogram` expects a length-2 `Vector` of images (the pair
of images) and returns a length-2 `Vector` of modified images.  The  function
can handle a variety of input types. The type of the returned image matches the
input type.

For colored images, the inputs are converted to
[YIQ](https://en.wikipedia.org/wiki/YIQ)  type and the distributions of the Y
channels are transformed according to a "midway" distribution. The modified Y
channel is then combined with the I and Q channels and the resulting image
converted to the same type as the input.

## Choices for `nbins`

You can specify the total number of bins in the histogram. If you do not
specify the number of bins then a default value of 256 bins is utilized.

## Choices for `edges`

If you do not designate the number of bins, then you have the option to directly
stipulate how the intervals will be divided by specifying a `AbstractRange`
type.

# Example

```julia
using Images, TestImages, ImageView, ImageContrastAdjustment

img = testimage("mandril_gray")

# The same image but with different intensitiy distributions
img1 = adjust_histogram(img, GammaCorrection(gamma = 2))
img2 = adjust_histogram(img, GammaCorrection(gamma = 1.2))

# Midway histogram equalization will transform these two images so that their
# intensity distributions are almost identical.
img_sequence = adjust_histogram([img1, img2], MidwayEqualization(nbins = 256))
img1o = first(img_sequence)
img2o = last(img_sequence)
```

# References
1. T. Guillemot and J. Delon, “*Implementation of the Midway Image Equalization*,” Image Processing On Line, vol. 5, pp. 114–129, Jun. 2016. [doi:10.5201/ipol.2016.140](https://doi.org/10.5201/ipol.2016.140)
"""
@with_kw struct MidwayEqualization{T₁ <: Union{Integer, Nothing},
                					  T₂ <: Union{AbstractRange, Nothing}} <: AbstractHistogramAdjustmentAlgorithm
    nbins::T₁ = 256
    edges::T₂ = nothing
end

function (f::MidwayEqualization)(out_sequence::Vector{<:GenericGrayImage}, in_sequence::Vector{<:GenericGrayImage})
    length(out_sequence) == 2 || error("Please supply a length-2 output vector to store the pair of images.")
    length(in_sequence) == 2 || error("Please supply a length-2 input vector storing the image pair.")
    out1 = first(out_sequence)
    out2 = last(out_sequence)
    in1 = first(in_sequence)
    in2 = last(in_sequence)
    out1 .= in1
    out2 .= in2
    edges, pdf1, pdf2 = isnothing(f.edges) ? construct_pdfs(out1, out2, f.nbins) : construct_pdfs(out1, out2, f.edges)
    midway_pdf = zero(pdf1)
    cdf1 = cumsum(pdf1)
    cdf2 = cumsum(pdf2)
    # midway_cdf is the harmonic mean between cdf1 and cdf2.
    midway_cdf =  similar(cdf1)
    for i in eachindex(cdf1)
        if cdf1[i] == 0 || cdf2[i] == 0
            midway_cdf[i] = 0
        else
            midway_cdf[i] = 2 / (1/cdf1[i] + 1/cdf2[i])
        end
    end
    cdf2pdf!(midway_pdf, midway_cdf)
    index₁ = firstindex(out_sequence)
    index₂ = lastindex(out_sequence)
    out_sequence[index₁]  = match_pdf!(out1, edges, pdf1, midway_pdf)
    out_sequence[index₂]  = match_pdf!(out2, edges, pdf2, midway_pdf)
end

function (f::MidwayEqualization)(out_sequence::Vector{<:AbstractArray{<:Color3}}, in_sequence::Vector{<:AbstractArray{<:Color3}})
    length(out_sequence) == 2 || error("Please supply a length-2 output vector to store the pair of images.")
    length(in_sequence) == 2 || error("Please supply a length-2 input vector storing the image pair.")
    out1 = first(out_sequence)
    out2 = last(out_sequence)
    in1 = first(in_sequence)
    in2 = last(in_sequence)

    T₁ = eltype(out1)
    T₂ = eltype(out2)

    out1 .= in1
    out2 .= in2

    in_yiq1 = convert.(YIQ, in1)
    in_yiq1_view = channelview(in_yiq1)
    in_yiq2 = convert.(YIQ, in2)
    in_yiq2_view = channelview(in_yiq2)
    in_yiq_view_sequence = [view(in_yiq1_view,1,:,:), view(in_yiq2_view,1,:,:)]

    out_yiq1 = convert.(YIQ, out1)
    out_yiq1_view = channelview(out_yiq1)
    out_yiq2 = convert.(YIQ, out2)
    out_yiq2_view = channelview(out_yiq2)
    out_yiq_view_sequence = [view(out_yiq1_view,1,:,:), view(out_yiq2_view,1,:,:)]

    adjust_histogram!(out_yiq_view_sequence, in_yiq_view_sequence, f)

    index₁ = firstindex(out_sequence)
    index₂ = lastindex(out_sequence)
    out_sequence[index₁] .= convert.(T₁, out_yiq1)
    out_sequence[index₂] .= convert.(T₂, out_yiq2)
end

(f::MidwayEqualization)(out_sequence::Vector{<:GenericGrayImage}, img_sequence::Vector{<:AbstractArray{<:Color3}}) =
    f(out_sequence, map(img -> of_eltype(Gray, img), img_sequence))

# This is a temporary module to validate `AbstractImageFilter` idea
# proposed in https://github.com/JuliaImages/ImagesAPI.jl/pull/3
module HistogramAdjustmentAPI

using ImageCore # ColorTypes is sufficient

# TODO Relax this to all image color types
using ..ImageContrastAdjustment: GenericGrayImage

"""
    AbstractImageAlgorithm

The root of image algorithms type system
"""
abstract type AbstractImageAlgorithm end

"""
    AbstractImageFilter <: AbstractImageAlgorithm

Filters are image algorithms whose input and output are both images
"""
abstract type AbstractImageFilter <: AbstractImageAlgorithm end

include("histogram_adjustment.jl")

# we do not export any symbols since we don't require
# package developers to implemente all the APIs

end  # module HistogramAdjustmentAPI

using ImageCore
using ImageContrastAdjustment
using Test

@testset "Contrast Stretching" begin

    for T in (Gray{N0f8}, Gray{N0f16}, Gray{Float32}, Gray{Float64})
        #=
        Create an image that spans a narrow graylevel range.  Then
        quantize the 256 bins down to 16 and determine how many bins have
        non-zero counts.
        =#
        img = T.([i/255.0 for i = 64:128, j = 1:10])
        _, counts_before = build_histogram(img,16, minval = 0, maxval = 1)
        nonzero_before = sum(counts_before .!= 0)

        #=
        Stretch the histogram. Then quantize the 256 bins down to 16 and
        verify that all 16 bins have non-zero counts. This will confirm that
        the dynamic range of the original image has been increased.
        =#
        ret = adjust_histogram(img, ContrastStretching(t = 0.4, slope = 17))
        edges, counts_after = build_histogram(ret,16, minval = 0, maxval = 1)
        nonzero_after = sum(counts_after .!= 0)
        @test nonzero_before < nonzero_after
        @test nonzero_after == 16
        @test eltype(img) == eltype(ret)
        if eltype(T) <: FixedPoint
            @test ret ≈ T.(adjust_histogram(float.(img), ContrastStretching(t = 0.4, slope = 17)))
        end

        #=
        Verify that the function can cope with a NaN value.
        =#
        if T <: Gray{Float32} || T <: Gray{Float64}
            img[1] = NaN
            ret = adjust_histogram(img, ContrastStretching(t = 0.4, slope = 17))
            edges, counts_after = build_histogram(ret,16, minval = 0, maxval = 1)
            nonzero_after = sum(counts_after .!= 0)
            @test nonzero_before < nonzero_after
            @test nonzero_after == 16
            @test eltype(img) == eltype(ret)
        end

        #=
        Verify that when the slope is set to a very large value the contrast
        streching behaves like a thresholding function.
        =#
        ret = adjust_histogram(img, ContrastStretching(t = 0.37, slope = 1000))
        edges, counts_after = build_histogram(ret,16, minval = 0, maxval = 1)
        @test sum(counts_after .!= 0) == 2
    end

    for T in (RGB{N0f8}, RGB{N0f16}, RGB{Float32}, RGB{Float64})
        #=
        Create a color image that spans a narrow graylevel range.  Then
        quantize the 256 bins down to 16 and determine how many bins have
        non-zero counts.
        =#
        imgg = Gray{Float32}.([i/255.0 for i = 64:128, j = 1:10])
        img = colorview(RGB,imgg,imgg,imgg)
        img = T.(img)
        _, counts_before = build_histogram(img, 16, minval = 0, maxval = 1)
        nonzero_before = sum(counts_before .!= 0)

        #=
        Stretch the histogram. Then quantize the 256 bins down to 16 and
        verify that all 16 bins have non-zero counts. This will confirm that
        the dynamic range of the original image has been increased.
        =#
        ret = adjust_histogram(img, ContrastStretching(t = 0.4, slope = 17))
        edges, counts_after = build_histogram(ret, 16, minval = 0, maxval = 1)
        nonzero_after = sum(counts_after .!= 0)
        @test nonzero_before < nonzero_after
        @test nonzero_after == 16
        @test eltype(img) == eltype(ret)

        #=
        Verify that when the slope is set to a very large value the contrast
        streching behaves like a thresholding function.
        =#
        ret = adjust_histogram(img, ContrastStretching(t = 0.37, slope = 1000))
        edges, counts_after = build_histogram(ret, 16, minval = 0, maxval = 1)
        @test sum(counts_after .!= 0) == 2
    end

    # Issue #58
    img = Gray{N0f8}.([1 0; 0 1])
    @test adjust_histogram(img, ContrastStretching(t=0.3, slope=0.4)) ==
          Gray{N0f8}.(adjust_histogram(float.(img), ContrastStretching(t=0.3, slope=0.4, ϵ=eps(N0f8))))
end

@testset "Linear Stretching" begin

    @testset "constructors" begin
        @test LinearStretching() === LinearStretching(nothing, nothing, 0.0f0, 1.0f0, nothing, nothing, false)
        @test LinearStretching(src_minval=0.1f0, src_maxval=0.9f0, dst_minval=0.05f0, dst_maxval=0.95f0, no_clamp=true) ===
              LinearStretching(0.1f0, 0.9f0, 0.05f0, 0.95f0, nothing, nothing, true)

        @test LinearStretching((0.1f0, 0.9f0)=>(0.2f0, 0.8f0)) === LinearStretching(0.1f0, 0.9f0, 0.2f0, 0.8f0)
        @test LinearStretching((0.1f0, 0.9f0)=>(0.2f0, 0.8f0), no_clamp=true) ===
              LinearStretching(0.1f0, 0.9f0, 0.2f0, 0.8f0, nothing, nothing, true)

        @test LinearStretching(nothing=>(0.2f0, 0.8f0)) === LinearStretching((nothing, nothing)=>(0.2f0, 0.8f0))
        @test LinearStretching(nothing=>(0.2f0, 0.8f0), no_clamp=true) ===
              LinearStretching((nothing, nothing)=>(0.2f0, 0.8f0), no_clamp=true)

        @test LinearStretching((0.1f0, 0.9f0)=>nothing, no_clamp=true) ===
              LinearStretching(0.1f0, 0.9f0, 0.0f0, 1.0f0, nothing, nothing, true)

        @test_throws MethodError LinearStretching(0.1f0, 0.9f0)
        @test_throws MethodError LinearStretching((0.1f0, 0.9f0), (0.0f0, 1.0f0))
        @test_throws ArgumentError LinearStretching((0.9f0, 0.1f0)=>nothing)
        @test_throws ArgumentError LinearStretching(nothing=>(0.9f0, 0.1f0))
        @test_throws ArgumentError LinearStretching((0.9f0, 0.1f0)=>(0.9f0, 0.1f0))
    end

    for T in (Gray{N0f8}, Gray{N0f16}, Gray{Float32}, Gray{Float64})
        #=
        Stretching an image consisting of a linear ramp should not change the image
        if the specified minimum and maximum values match the minimum and maximum of
        the image.
        =#
        img = T.(collect(reshape(1/100:1/100:1, 10, 10)))
        minval = minimum(img)
        maxval = maximum(img)
        ret =  adjust_histogram(img, LinearStretching(nothing=>(minval, maxval)))
        if T <: Gray{Float32} || T <: Gray{Float64}
            @test all(map((i, r) -> isapprox(i, r), img, ret))
        else
            @test ret == img
        end

        # Verify that NaN is also handled correctly.
        if T <: Gray{Float32} || T <: Gray{Float64}
            img[10] = NaN
            ret = adjust_histogram(img, LinearStretching(nothing=>(minval, maxval)))
            @test isapprox(first(img), first(ret))
            @test isapprox(last(img), last(ret))
            @test isnan(ret[10])
        end

        # Verify that the smallest and largest values match the specified minval and maxval.
        img = T.(collect(reshape(1/100:1/100:1, 10, 10)))
        minval = minimum(img)
        maxval = maximum(img)
        ret =  adjust_histogram(img, LinearStretching(nothing=>(0, 1)))
        @test isapprox(0, first(ret))
        @test isapprox(1, last(ret))
        @test isapprox(0, minimum(ret[.!isnan.(ret)]))
        @test isapprox(1, maximum(ret[.!isnan.(ret)]))

        # Verify that the return type matches the input type.
        img = T.(testimage("mandril_gray"))
        ret = adjust_histogram(img, LinearStretching(nothing=>(0, 1)))
        @test eltype(ret) == eltype(img)
        @test isapprox(0, minimum(ret))
        @test isapprox(1, maximum(ret))

        ret = adjust_histogram(img, LinearStretching(nothing=>(0.2, 0.8)))
        @test eltype(ret) == eltype(img)
        @test isapprox(0.2, minimum(ret))
        @test isapprox(0.8, maximum(ret))

        # Verify that results are correctly clamped to [0.2, 0.9] if it exceeds the range
        ret = adjust_histogram(img, LinearStretching((0.1, 0.8)=>(0.2, 0.9)))
        @test eltype(ret) == eltype(img)
        @test isapprox(T(0.2), minimum(ret))
        @test isapprox(T(0.9), maximum(ret), atol=1e-2)
    end

    # Verify that no_clamp option handles different input types correctly without ArgumentError
    img = Float32.(testimage("mandril_gray"))
    ret_clamp = adjust_histogram(img, LinearStretching((0.3, 0.8)=>(0.1, 1.1), no_clamp=true))
    @test eltype(ret_clamp) == eltype(img)
    @test isapprox(-0.5f0, minimum(ret_clamp))
    @test isapprox(1.272549f0, maximum(ret_clamp))
    ret_noclamp = adjust_histogram(img, LinearStretching((0.3, 0.8)=>(0.1, 1.1), no_clamp=false))
    @test eltype(ret_noclamp) == eltype(img)
    @test isapprox(0.1f0, minimum(ret_noclamp))
    @test isapprox(1.1f0, maximum(ret_noclamp))
    # when no_clamp==true, the output is still clamped by (typemin(T), typemax(T))
    img = N0f8.(testimage("mandril_gray"))
    ret_clamp = adjust_histogram(img, LinearStretching((0.3, 0.8)=>(0.1, 1.1), no_clamp=true))
    @test eltype(ret_clamp) == eltype(img)
    @test isapprox(0.0N0f8, minimum(ret_clamp))
    @test isapprox(1.0N0f8, maximum(ret_clamp))
    ret_noclamp = adjust_histogram(img, LinearStretching((0.3, 0.8)=>(0.1, 1.1), no_clamp=false))
    @test eltype(ret_noclamp) == eltype(img)
    @test isapprox(0.1N0f8, minimum(ret_noclamp))
    @test isapprox(1.0N0f8, maximum(ret_noclamp))
    @test ret_clamp != ret_noclamp

    for T in (RGB{N0f8}, RGB{N0f16}, RGB{Float32}, RGB{Float64})
        #=
        Create a color image that spans a narrow graylevel range.  Then
        quantize the 256 bins down to 32 and determine how many bins have
        non-zero counts.
        =#
        imgg = Gray{Float32}.([i/255.0 for i = 64:128, j = 1:10])
        img = colorview(RGB,imgg,imgg,imgg)
        img = T.(img)
        _, counts_before = build_histogram(img,32, minval = 0, maxval = 1)
        nonzero_before = sum(counts_before .!= 0)

        #=
        Stretch the histogram. Then quantize the 256 bins down to 32 and
        verify that all 32 bins have non-zero counts. This will confirm that
        the dynamic range of the original image has been increased.
        =#
        ret = adjust_histogram(img, LinearStretching(nothing=>(0, 1)))
        edges, counts_after = build_histogram(ret, 32, minval = 0, maxval = 1)
        nonzero_after = sum(counts_after .!= 0)
        @test nonzero_before < nonzero_after
        @test nonzero_after == 32
        @test eltype(img) == eltype(ret)
    end

    @testset "deprecations" begin
        @info "four depwarns are expected"
        @test LinearStretching(minval = 0.1) === LinearStretching(dst_minval = 0.1)
        @test LinearStretching(maxval = 0.9) === LinearStretching(dst_maxval = 0.9)
        @test LinearStretching(minval = 0.1, maxval = 0.9) === LinearStretching(dst_minval = 0.1, dst_maxval = 0.9)
    end
end

@testset "Contrast Limited Adaptive Histogram Equalisation" begin
    for T in (Gray{N0f8}, Gray{N0f16}, Gray{Float32}, Gray{Float64})
        # Create a graylevel ramp
        img = Gray{Float32}.([i/255.0 for i = 64:127, j = 1:64])
        img = T.(img)
        for rblocks in 2:4
            for cblocks in 2:4
                # There should be no change in intensity along a row.
                algo = AdaptiveEqualization(nbins = 256, minval = 0, maxval = 1,
                                            rblocks = rblocks, cblocks = cblocks,
                                            clip = 0.0)
                imgeq = adjust_histogram(img, algo)
                target = repeat(imgeq[:,1], inner=(1, 1), outer=(1, 64))
                @test all(imgeq .≈ target)

                # There should be no change in intensity along a column
                imgeq = adjust_histogram(transpose(img), algo)
                target =  transpose(repeat(imgeq[1, :], inner=(1, 1), outer=(1, 64)))
                @test all(imgeq .≈ target)
            end
        end

    end

    #=
    When rblocks and cblocks equal one and clip is zero,  then the method boils
    down to canonical histogram equalization. Hence, we repeat the same tests
    here that we have in histgoram_equalization.jl.
    =#

    for T in (Gray{N0f8}, Gray{N0f16}, Gray{Float32}, Gray{Float64})
        #=
        Create an image that spans a narrow graylevel range. Then quantize
        the 256 bins down to 32 and determine how many bins have non-zero
        counts.
        =#

        img = Gray{Float32}.([i/255.0 for i = 64:128, j = 1:10])
        img = T.(img)
        _, counts_before = build_histogram(img, 32, minval = 0, maxval = 1)
        nonzero_before = sum(counts_before .!= 0)

        #=
        Equalize the image histogram. Then quantize the 256 bins down to 32
        and verify that all 32 bins have non-zero counts. This will confirm
        that the dynamic range of the original image has been increased.
        =#
        algo = AdaptiveEqualization(nbins = 256, minval = 0, maxval = 1,
                                    rblocks = 1, cblocks = 1, clip = 0.0)
        imgeq = adjust_histogram(img, algo)
        edges, counts_after = build_histogram(imgeq, 32, minval = 0, maxval = 1)
        nonzero_after = sum(counts_after .!= 0)
        @test nonzero_before < nonzero_after
        @test nonzero_after == 32
    end


    for T in (RGB{N0f8}, RGB{N0f16}, RGB{Float32}, RGB{Float64})
        #=
        Create a color image that spans a narrow graylevel range.  Then
        quantize the 256 bins down to 32 and determine how many bins have
        non-zero counts.
        =#

        imgg = Gray{Float32}.([i/255.0 for i = 64:128, j = 1:10])
        img = colorview(RGB,imgg,imgg,imgg)
        img = T.(img)
        _, counts_before = build_histogram(img, 32, minval = 0, maxval = 1)
        nonzero_before = sum(counts_before .!= 0)

        #=
        Equalize the histogram. Then quantize the 256 bins down to 32 and
        verify that all 32 bins have non-zero counts. This will confirm that
        the dynamic range of the original image has been increased.
        =#
        algo = AdaptiveEqualization(nbins = 256, minval = 0, maxval = 1,
                                    rblocks = 1, cblocks = 1, clip = 0.0)
        imgeq = adjust_histogram(img, algo)
        edges, counts_after = build_histogram(imgeq, 32, minval = 0, maxval = 1)
        nonzero_after = sum(counts_after .!= 0)
        @test nonzero_before < nonzero_after
        @test nonzero_after == 32
    end

    # Verify that the minimum and maximum values of the equalised image match the
    # specified minimum and maximum values, i.e. that the intensities of the equalised
    # image are in the interval [minvalue, maxvalue].
    algo = AdaptiveEqualization(nbins = 256, minval = 64, maxval = 128,
                                rblocks = 1, cblocks = 1, clip = 0.0)
    imgeq = adjust_histogram(hcat(collect(0:1:255), collect(0:1:255)), algo)
    @test all(imgeq[1:65, :] .== 64)
    @test all(imgeq[128+1:end, :] .== 128)

    algo = AdaptiveEqualization(nbins = 256, minval = 64/255, maxval = 128/255,
                                rblocks = 1, cblocks = 1, clip = 0.0)
    imgeq = adjust_histogram(hcat(collect(0:1/255:1), collect(0:1/255:1)), algo)
    @test all(imgeq[1:65, :] .== 64/255)
    @test all(imgeq[128+1:end, :] .== 128/255)

    # Verify that increasing the clip value reduces the strength of the contrast
    # adjustment
    img = Gray{Float32}.(testimage("mandril_gray"))
    # As we increase the clip factor the contrast adjustment is diminished and we
    # should approach the original image.
    algo₁ = AdaptiveEqualization(nbins = 256, minval = 0, maxval = 1, rblocks = 1, cblocks = 1, clip = 0.0)
    algo₂ = AdaptiveEqualization(nbins = 256, minval = 0, maxval = 1, rblocks = 1, cblocks = 1, clip = 0.25)
    algo₃ = AdaptiveEqualization(nbins = 256, minval = 0, maxval = 1, rblocks = 1, cblocks = 1, clip = 0.5)
    algo₄ = AdaptiveEqualization(nbins = 256, minval = 0, maxval = 1, rblocks = 1, cblocks = 1, clip = 0.75)
    algo₅ = AdaptiveEqualization(nbins = 256, minval = 0, maxval = 1, rblocks = 1, cblocks = 1, clip = 1.0)
    algos = [algo₁, algo₂, algo₃, algo₄, algo₅]
    differences = [norm(adjust_histogram(img, algos[i]) .- img) for i = 1:5]
    @test all([differences[i] > differences[i+1] for i = 1:4])
    @test last(differences) < 2.8

    # Verify that auotmatically converting a color image and storing the histogram
    # adjusted result "inplace" works correctly.
    algo = AdaptiveEqualization(nbins = 256, minval = 0, maxval = 1, rblocks = 1, cblocks = 1, clip = 0)
    imgg₁ = Gray{Float32}.([i/255.0 for i = 64:128, j = 1:10])
    imgg₂ = copy(imgg₁)
    img = colorview(RGB,imgg₁,imgg₁,imgg₁)
    imgeq₁ = adjust_histogram!(imgg₁,img, algo)
    imgeq₂ = adjust_histogram(imgg₂, algo)
    @test norm(imgeq₁ .- imgeq₂) ≈ 0.0
end

@testset "CLAHE regression: Avoid failure on Gray{N0f8} images " begin 
    # https://github.com/JuliaImages/ImageContrastAdjustment.jl/issues/64
    rng = StableRNG(123)
    img = Gray{N0f8}.(rand(rng, 600, 600))
    minval = 0
    maxval = 1
    algo = AdaptiveEqualization( nbins = 256, minval = minval, maxval = maxval, rblocks = 4, cblocks = 4, clip = 0.2)
    imgeq = adjust_histogram(img, algo)
    @test minimum(imgeq) >= Gray{N0f8}(minval)
    @test maximum(imgeq) <= Gray{N0f8}(maxval)
end 

@testset "CLAHE supports raw UInt8 arrays without conversion failure" begin
    img = UInt8.([round(Int, 240 + 15 * sin(r / 8)) for r = 1:64, c = 1:64])
    minval = 0
    maxval = 255
    algo = AdaptiveEqualization(nbins = 256, minval = minval, maxval = maxval, rblocks = 8, cblocks = 8, clip = 0.2)
    imgeq = adjust_histogram(img, algo)
    @test eltype(imgeq) == UInt8
    @test minimum(imgeq) >= minval
    @test maximum(imgeq) <= maxval 
end

    @testset "Histogram Equalisation" begin

    for T in (Gray{N0f8}, Gray{N0f16}, Gray{Float32}, Gray{Float64})
        #=
        Create an image that spans a narrow graylevel range. Then quantize
        the 256 bins down to 32 and determine how many bins have non-zero
        counts.
        =#

        img = Gray{Float32}.([i/255.0 for i = 64:128, j = 1:10])
        img = T.(img)
        _, counts_before = build_histogram(img, 32, minval = 0, maxval = 1)
        nonzero_before = sum(counts_before .!= 0)

        #=
        Equalize the image histogram. Then quantize the 256 bins down to 32
        and verify that all 32 bins have non-zero counts. This will confirm
        that the dynamic range of the original image has been increased.
        =#
        imgeq = adjust_histogram(img, Equalization(nbins = 256, minval = 0, maxval = 1))
        edges, counts_after = build_histogram(imgeq, 32, minval = 0, maxval = 1)
        nonzero_after = sum(counts_after .!= 0)
        @test nonzero_before < nonzero_after
        @test nonzero_after == 32
    end


    for T in (RGB{N0f8}, RGB{N0f16}, RGB{Float32}, RGB{Float64})
        #=
        Create a color image that spans a narrow graylevel range.  Then
        quantize the 256 bins down to 32 and determine how many bins have
        non-zero counts.
        =#

        imgg = Gray{Float32}.([i/255.0 for i = 64:128, j = 1:10])
        img = colorview(RGB,imgg,imgg,imgg)
        img = T.(img)
        _, counts_before = build_histogram(img, 32, minval = 0, maxval = 1)
        nonzero_before = sum(counts_before .!= 0)

        #=
        Equalize the histogram. Then quantize the 256 bins down to 32 and
        verify that all 32 bins have non-zero counts. This will confirm that
        the dynamic range of the original image has been increased.
        =#
        imgeq = adjust_histogram(img,Equalization(nbins = 256, minval = 0, maxval = 1))
        edges, counts_after = build_histogram(imgeq, 32, minval = 0, maxval = 1)
        nonzero_after = sum(counts_after .!= 0)
        @test nonzero_before < nonzero_after
        @test nonzero_after == 32
    end

    # Verify that the minimum and maximum values of the equalised image match the
    # specified minimum and maximum values, i.e. that the intensities of the equalised
    # image are in the interval [minvalue, maxvalue].
    imgeq = adjust_histogram(collect(0:1:255), Equalization(nbins = 256, minval = 64, maxval = 128))
    @test all(imgeq[1:65] .== 64)
    @test all(imgeq[128+1:end] .== 128)

    imgeq = adjust_histogram(collect(0:1/255:1), Equalization(nbins = 256, minval = 64/255, maxval = 128/255))
    @test all(imgeq[1:65] .== 64/255)
    @test all(imgeq[128+1:end] .== 128/255)
end

"""
```
    ContrastStretching <: AbstractHistogramAdjustmentAlgorithm
    ContrastStretching(; t = 0.5,  slope = 1.0)

    adjust_histogram([T,] img, f::ContrastStretching)
    adjust_histogram!([out,] img, f::ContrastStretching)
```

Returns an image where intensities below `t` are compressed into a narrower
range of dark intensities, and values above `t` are compressed into a narrower
band of light intensities.

# Details

Contrast stretching is a transformation that  enhances or reduces (for `slope` >
1 or < 1, respectively) the contrast near saturation (0 and 1).
It is given by the relation
```math
f(x) = \\frac{1}{1 + \\left(\\frac{t}{x} \\right)^s}, \\; s \\in \\mathbb{R},
```
where ``s`` represents the `slope` argument.

# Options

Various options for the parameters of the `adjust_histogram` and
`ContrastStretching` type are described in more detail below.

## Choices for `img`

The function can handle a variety of input types. The returned
image depends on the input type.

For colored images, the input is converted to the
[YIQ](https://en.wikipedia.org/wiki/YIQ)  type and the intensities of the Y
channel are stretched to the specified range. The modified Y channel is then
combined with the I and Q channels and the resulting image converted to the same
type as the input.

## Choice for `t`

The value of `t` needs to be in the unit interval. If left unspecified a
default value of 0.5 is utilized.

## Choice for `slope`

The value of `slope` can be any real number. If left unspecified a
default value of 1.0 is utilized.

# Example

```julia
using ImageContrastAdjustment, ImageView, TestImages

img = testimage("mandril_gray")
ret = adjust_histogram(img, ContrastStretching(t = 0.6, slope = 3))

```

# References
1. Gonzalez, R. C., Woods, R. E., & Eddins, S. L. (2004). *Digital image processing using MATLAB* (Vol. 624). Upper Saddle River, New Jersey: Pearson-Prentice-Hall.

"""
@with_kw struct ContrastStretching{T₁ <: Union{Real,AbstractGray},
                                      T₂ <: Union{Real,AbstractGray}}  <: AbstractHistogramAdjustmentAlgorithm
     t::T₁ = 0.5
     slope::T₂ = 1.0
     ϵ::Union{T₁,Nothing} = nothing
end
ContrastStretching(t::T₁, slope::T₂, ϵ::Union{Real,AbstractGray}) where {T₁ <: Union{Real,AbstractGray},
                                             T₂ <: Union{Real,AbstractGray}} =
    ContrastStretching{T₁,T₂}(t, slope, T₁(ϵ))

function (f::ContrastStretching)(out::GenericGrayImage, img::GenericGrayImage)
    T = eltype(out)
    ϵ = f.ϵ === nothing ? eps(T) : f.ϵ
    out .= img
    map!(out,out) do val
        if isnan(val)
            return val
        else
            newval = contrast_stretch(val, f.t, f.slope, ϵ)
            return  T <: Integer ? round(Int, newval ) : newval
        end
    end
end

function (f::ContrastStretching)(out::AbstractArray{<:Color3}, img::AbstractArray{<:Color3})
    T = eltype(img)
    yiq = convert.(YIQ, img)
    yiq_view = channelview(yiq)
    adjust_histogram!(view(yiq_view,1,:,:), f)
    out .= convert.(T, yiq)
end

(f::ContrastStretching)(out::GenericGrayImage, img::AbstractArray{<:Color3}) =
    f(out, of_eltype(Gray, img))

function contrast_stretch(x, t, s, ϵ)
    return 1 / (1 + (t / (x+ϵ))^s)
end
contrast_stretch(x::Union{FixedPoint,AbstractGray{<:FixedPoint}}, t, s, ϵ) = contrast_stretch(float(x), t, s, ϵ)

"""
```
    GammaCorrection <: AbstractHistogramAdjustmentAlgorithm
    GammaCorrection(; gamma = 1)

    adjust_histogram([T,] img, f::GammaCorrection)
    adjust_histogram!([out,] img, f::GammaCorrection)
```

Returns a gamma corrected image.

# Details


Gamma correction is a non-linear  transformation given by the relation
```math
f(x) = x^\\gamma \\quad \\text{for} \\; x \\in \\mathbb{R}, \\gamma > 0.
```
It is called a *power law* transformation because one quantity varies as a power
of another quantity.

Gamma correction has historically been used to preprocess
an image to compensate for the fact that the intensity of light generated by a
physical device is not usually a linear function of the applied signal but
instead follows a power law [1]. For example, for many Cathode Ray Tubes (CRTs) the
emitted light intensity on the display is approximately equal to the voltage
raised to the power of γ, where γ ∈ [1.8, 2.8]. Hence preprocessing a raw image with
an exponent of 1/γ  would have ensured a linear response to brightness.

Research in psychophysics has also established an [empirical  power law
](https://en.wikipedia.org/wiki/Stevens%27s_power_law)  between light intensity and perceptual
brightness. Hence, gamma correction often serves as a useful image enhancement
tool.


# Options

Various options for the parameters of the `adjust_histogram` function and the
`Gamma` type are described in more detail below.

## Choices for `img`

The function can handle a variety of input types. The returned
image depends on the input type.

For colored images, the input is converted to YIQ type and the Y channel is
gamma corrected. This is the combined with the I and Q channels and the
resulting image converted to the same type as the input.

## Choice for `gamma`

The `gamma` value must be a non-zero positive number. A `gamma` value less than
one will yield a brighter image whereas a value greater than one will produce a
darker image. If left unspecified a default value of one is assumed.

# Example

```julia
using ImageContrastAdjustment, ImageView

# Create an example image consisting of a linear ramp of intensities.
n = 32
intensities = 0.0:(1.0/n):1.0
img = repeat(intensities, inner=(20,20))'

# Brighten the dark tones.
imgadj = adjust_histogram( img, GammaCorrection(gamma = 1/2))

# Display the original and adjusted image.
imshow(img)
imshow(imgadj)
```

# References
1. W. Burger and M. J. Burge. *Digital Image Processing*. Texts in Computer Science, 2016. [doi:10.1007/978-1-4471-6684-9](https://doi.org/10.1007/978-1-4471-6684-9)
"""
@with_kw struct GammaCorrection{T <: Real} <: AbstractHistogramAdjustmentAlgorithm
    gamma::T = 1.0
end

function (f::GammaCorrection)(out::GenericGrayImage, img::GenericGrayImage)
    out .= img
    correct_gamma!(out, f.gamma)
    return out
end

# TODO Expand this to more generic gray color types.
function correct_gamma!(img::AbstractArray{Gray{T}},  gamma::Real) where T <: FixedPointNumbers.Normed
    γ = Float64(gamma)
    # Create a lookup-table for the gamma transformation of the grayvalues.
    raw_type = FixedPointNumbers.rawtype(T)
    table = zeros(T, typemax(raw_type) + 1)
    for i in zero(raw_type):typemax(raw_type)
        table[i + 1] = T((i / typemax(raw_type))^γ)
    end
    # Map the pixels to their new grayvalues.
    map!(img,img) do p
        table[p.val.i + 1]
    end
end

function correct_gamma!(img::GenericGrayImage,  gamma::Real)
    γ = Float64(gamma)
    T = eltype(img)
    map!(img,img) do val
        if isnan(val)
            return val
        else
            return  T <: Integer ? round(Int, val^γ) : val^γ
        end
    end
end

function (f::GammaCorrection)(out::AbstractArray{<:Color3}, img::AbstractArray{<:Color3})
    T = eltype(out)
    yiq = convert.(YIQ, img)
    yiq_view = channelview(yiq)
    adjust_histogram!(view(yiq_view,1,:,:), f)
    out .= convert.(T, yiq)
end

(f::GammaCorrection)(out::GenericGrayImage, img::AbstractArray{<:Color3}) =
    f(out, of_eltype(Gray, img))

"""
```
    AdaptiveEqualization <: AbstractHistogramAdjustmentAlgorithm
    AdaptiveEqualization(; nbins = 256, minval = 0, maxval = 1, rblocks = 8, cblocks = 8, clip = 0.1)

    adjust_histogram([T,] img, f::AdaptiveEqualization)
    adjust_histogram!([out,] img, f::AdaptiveEqualization)
```

Performs Contrast Limited Adaptive Histogram Equalisation (CLAHE) on the input
image. It differs from ordinary histogram equalization in the respect that the
adaptive method computes several histograms, each corresponding to a distinct
section of the image, and uses them to redistribute the lightness values of the
image. It is therefore suitable for improving the local contrast and enhancing
the definitions of edges in each region of an image.

# Details

Histogram equalisation was initially conceived to  improve the contrast in a
single-channel grayscale image. The method transforms the distribution of the
intensities in an image so that they are as uniform as possible [1]. The natural
justification for uniformity is that the image has better contrast  if the
intensity levels of an image span a wide range on the intensity scale. As it
turns out, the necessary transformation is a mapping based on the cumulative
histogram---see [Equalization](@ref) for more details.

A natural extension of histogram equalisation is to apply the contrast
enhancement locally rather than globally [2]. Conceptually, one can imagine that
the process involves partitioning the image into a grid of rectangular regions
and applying histogram equalisation based on the local CDF of each contextual
region. However, to smooth the transition of the pixels from one contextual
region to another,  the mapping of a pixel is not necessarily done soley based
on the local CDF of its contextual region. Rather, the mapping of a pixel may be
interpolated based on the CDF of its contextual region, and the CDFs of the
immediate neighbouring regions.

In adaptive histogram equalisation the image ``\\mathbf{G}`` is partitioned into
``P \\times Q`` equisized submatrices,
```math
\\mathbf{G} =  \\begin{bmatrix}
\\mathbf{G}_{11} & \\mathbf{G}_{12} & \\ldots & \\mathbf{G}_{1C} \\\\
\\mathbf{G}_{21} & \\mathbf{G}_{22} & \\ldots & \\mathbf{G}_{2C} \\\\
\\vdots & \\vdots & \\ldots & \\vdots \\\\
\\mathbf{G}_{R1} & \\mathbf{G}_{R2} & \\ldots & \\mathbf{G}_{RC} \\\\
\\end{bmatrix}.
```

For each submatrix ``\\mathbf{G}_{rc}``, one computes a concomitant CDF, which we
shall denote by ``T_{rc}(G_{i,j})``. In the most general case, we will require
four CDFs
```math
\\begin{aligned}
T_1(v)  & \\triangleq  T_{rc}(G_{i,j}) \\\\
T_2(v)  & \\triangleq  T_{(r+1)c}(G_{i,j}) \\\\
T_3(v)  & \\triangleq  T_{(r+1)(c+1)}(G_{i,j}) \\\\
T_4(v)  & \\triangleq  T_{r(c+1)}(G_{i,j}).
\\end{aligned}
```

In order to determine which particular CDFs will be
used in the interpolation step, it is useful to (i) introduce the function

```math
\\Phi(\\mathbf{G}_{rc}) = \\left(  \\phi_{rc},  \\phi'_{rc}\\right) \\triangleq \\left(rP - \\frac{P}{2}, cQ - \\frac{Q}{2} \\right),
```

(ii) form the sequences  ``\\left(\\phi_{11}, \\phi_{21}, \\ldots, \\phi_{R1} \\right)``
and ``\\left(\\phi'_{11}, \\phi'_{12}, \\ldots, \\phi'_{1C} \\right)``, and (iii) define

```math
\\begin{aligned}
t  & \\triangleq  \\frac{i - \\phi_{r1}}{\\phi_{(r+1)1} - \\phi_{r1} } \\\\
u  & \\triangleq  \\frac{j - \\phi'_{1c}}{\\phi'_{1(c+1)} - \\phi'_{1c} }.
\\end{aligned}
```

#### Case I (Interior)
For a  pixel ``G_{i,j}`` in the range

```math
P - \\frac{P}{2} \\le i \\le RP - \\frac{P}{2}  \\quad \\text{and}  \\quad  Q - \\frac{Q}{2} \\le j \\le CQ - \\frac{Q}{2}.
```
values of ``r`` and ``c`` are implicitly defined by the solution to the inequalities
```math
\\phi_{r1} \\le i < \\phi_{(r+1)1}  \\quad \\text{and}  \\quad  \\phi'_{1c} \\le j < \\phi'_{1(c+1)}.
```

The *bilinearly interpolated* transformation that maps an intensity ``v`` at location ``(i,j)`` in the image
to an intensity ``v'`` is given by [3]

```math
v' \\triangleq \\bar{T}(v)  = (1-t) (1-u)T_1(G_{i,j}) + t(1-u)T_2(G_{i,j}) + tuT_3(G_{i,j}) +(1-t)uT_4(G_{i,j}).
```

#### Case II (Vertical Border)

For a  pixel ``G_{i,j}`` in the range

```math
P - \\frac{P}{2} \\le i \\le RP - \\frac{P}{2}  \\quad \\text{and}  \\quad  1 \\le j < Q - \\frac{Q}{2}  \\; \\cup \\;   CQ - \\frac{Q}{2} < j \\le CQ,
```

``r`` is implicitly defined by the solution to the inequality ``\\phi_{r1} \\le i < \\phi_{(r+1)1}``, while

```math
c = \\begin{cases}
   1, & \\text{if }  \\quad  1 \\le j < Q - \\frac{Q}{2}  \\\\
   C, & \\text{if } \\quad   CQ - \\frac{Q}{2} < j \\le CQ.
\\end{cases}
```

The *linearly interpolated* transformation that maps an intensity ``v`` at location ``(i,j)`` in the image
to an intensity ``v'`` is given by

```math
v' \\triangleq \\bar{T}(v)  = (1-t)T_1(G_{i,j}) + tT_2(G_{i,j}).
```

#### Case III (Horizontal Border)

For a  pixel ``G_{i,j}`` in the range

```math
1 \\le i < P - \\frac{P}{2}  \\;\\cup \\;   RP - \\frac{P}{2} < i \\le RP    \\quad \\text{and}  \\quad  Q - \\frac{Q}{2} \\le j \\le CQ - \\frac{Q}{2},
```

``c`` is implicitly defined by the solution to the inequality ``\\phi'_{1c} \\le j < \\phi'_{1(c+1)}``, while
```math
r = \\begin{cases}
   1, & \\text{if }  \\quad  1 \\le i < P - \\frac{P}{2}  \\\\
   R, & \\text{if } \\quad   RP - \\frac{P}{2} < i \\le RP .
\\end{cases}
```

The *linearly interpolated* transformation that maps an intensity ``v`` at location ``(i,j)`` in the image
to an intensity ``v'`` is given by

```math
v' \\triangleq \\bar{T}(v)  = (1-u)T_1(G_{i,j}) + uT_4(G_{i,j}).
```

#### Case IV (Corners)
For a  pixel ``G_{i,j}`` in the range

```math
1 \\le i < \\frac{P}{2}  \\;\\cup \\; RP - \\frac{P}{2} < i \\le RP   \\quad \\text{and}  \\quad  1 \\le j < CQ -  \\frac{Q}{2} \\; \\cup \\;   CQ - \\frac{Q}{2} < j \\le CQ ,
```
we have
```math
r = \\begin{cases}
   1, & \\text{if }  \\quad  1 \\le i < P - \\frac{P}{2}  \\\\
   R, & \\text{if } \\quad   RP - \\frac{P}{2} < i \\le RP
\\end{cases}
 \\quad \\text{and}  \\quad
c = \\begin{cases}
   1, & \\text{if }  \\quad  1 \\le j < Q - \\frac{Q}{2}  \\\\
   C, & \\text{if } \\quad   CQ - \\frac{Q}{2} < j \\le CQ.
\\end{cases}
```
The transformation that maps an intensity ``v`` at location ``(i,j)`` in the image
to an intensity ``v'`` is given by

```math
v' \\triangleq \\bar{T}(v)  = T_1(G_{i,j}).
```

## Limiting Contrast
An unfortunate side-effect of contrast enhancement is that it has a tendency to
amplify the level of noise in an image, especially when the magnitude of the
contrast enhancement is very high. The magnitude of contrast enhancement is
associated with the gradient of ``T(\\cdot)``, because the  gradient determines the
extent to which consecutive input intensities are stretched across the
grey-level spectrum. One can diminish the level of noise amplification by
limiting the magnitude of the contrast enhancement, that is, by limiting the
magnitude of the gradient.

Since the derivative of ``T(\\cdot)`` is the empirical density ``\\hat{f}_{G}``,
the slope of the mapping function at any input intensity is proportional to the
height of the histogram  ``\\hat{f}_{G}`` at that intensity.  Therefore,
limiting the slope of the local mapping function is equivalent to clipping the
height of the histogram. A detailed description of the  implementation  details
of the clipping process can be found in [2].

# Options

Various options for the parameters of this function are described in more detail
below.

## Choices for `img`

The function can handle a variety of input types. The returned image
depends on the input type.

For coloured images, the input is converted to
[YIQ](https://en.wikipedia.org/wiki/YIQ) type and the Y channel is equalised.
This is the combined with the I and Q channels and the resulting image converted
to the same type as the input.

## Choices for `nbins` in `AdaptiveEqualization`

You can specify the total number of bins in the histogram of each local region.

## Choices for `rblocks` and `cblocks` in `AdaptiveEqualization`

The `rblocks` and `cblocks` specify the number of blocks to divide the input
image into in each direction. By default both values are set to eight.

## Choices for `clip` in `AdaptiveEqualization`

The `clip` parameter must be a value between 0 and 1. It defines an implicit
threshold at which a histogram is clipped. Counts that exceed the threshold are
redistributed as equally as possible so that no bin exceeds the threshold limit.
A value of zero means no clipping, whereas a value of one sets the threshold at
the smallest feasible bin limit. A bin limit is feasible if all bin counts can be
redistributed such that no bin count exceeds the limit. In practice, a `clip` value
of zero corresponds to maximal contrast enhancement, whereas a `clip` value of
one corredponds to minimal contrast enhancement. The default value is `0.1`.

## Choices for `minval` and `maxval` in `AdaptiveEqualization`

If `minval` and `maxval` are specified then intensities are equalized to the range
[`minval`, `maxval`]. The default values are 0 and 1.

# Example

```julia

using TestImages, FileIO, ImageView

img =  testimage("mandril_gray")
imgeq = adjust_histogram(img, AdaptiveEqualization(nbins = 256, rblocks = 4, cblocks = 4, clip = 0.2))

imshow(img)
imshow(imgeq)
```

# References
1. R. C. Gonzalez and R. E. Woods. *Digital Image Processing (3rd Edition)*.  Upper Saddle River, NJ, USA: Prentice-Hall,  2006.
2. S. M. Pizer, E. P. Amburn, J. D. Austin, R. Cromartie, A. Geselowitz, T. Greer, B. ter Haar Romeny, J. B. Zimmerman and K. Zuiderveld “Adaptive histogram equalization and its variations,” *Computer Vision, Graphics, and Image Processing*, vol. 38, no. 1, p. 99, Apr. 1987. [10.1016/S0734-189X(87)80186-X](https://doi.org/10.1016/s0734-189x(87)80156-1)
3. W. H. Press, S. A. Teukolsky, W. T. Vetterling, and B. P. Flannery.  *Numerical Recipes: The Art of Scientific Computing (3rd Edition)*. New York, NY, USA: Cambridge University Press, 2007.
"""
@with_kw struct AdaptiveEqualization{T₁ <: Union{Real,AbstractGray},
                                        T₂ <: Union{Real,AbstractGray},
                                        T₃ <: Real} <: AbstractHistogramAdjustmentAlgorithm
    nbins::Int = 256
    minval::T₁ = 0.0
    maxval::T₂ = 1.0
    rblocks::Int = 8
    cblocks::Int = 8
    clip::T₃ = 0.1
end

function (f::AdaptiveEqualization)(out::GenericGrayImage, img::GenericGrayImage)
    validate_parameters(f)
    height, width = length.(axes(img))
    # If necessary, resize the image so that the requested number of blocks fit exactly.
    resized_height = ceil(Int, height / (2 * f.rblocks)) * 2 * f.rblocks
    resized_width = ceil(Int, width / (2 * f.cblocks)) * 2 * f.cblocks
    must_resize = (resized_height != height) || (resized_width != width) ? true : false
    if must_resize
        img_tmp = imresize(img, (resized_height, resized_width))
        out_tmp = copy(img_tmp)
    else
        img_tmp = img
        out_tmp = out
    end

    # Determine the relevant pixel coordinates for each block.
    block_height = resized_height ÷  f.rblocks
    block_width =  resized_width ÷  f.cblocks
    r_intervals = [StepRange((r - 1) * block_height + 1, 1, r * block_height) for r = 1:f.rblocks]
    c_intervals = [StepRange((c - 1) * block_width + 1, 1, c * block_width) for c = 1:f.cblocks]

    function construct_hist(roi::AbstractArray)
        edges, histogram = build_histogram(roi, f.nbins, minval = f.minval, maxval = f.maxval)
    end

    function construct_cdf(edges::AbstractArray, histogram::AbstractArray)
        lb = first(axes(histogram, 1))
        ub = last(axes(histogram, 1))
        csum = cumsum(histogram[lb:ub])
        cdf = csum / csum[end]
        return edges, cdf
    end

    # Construct a histogram for each block in the image.
    block_hist = [construct_hist(view(img_tmp, r_intervals[r], c_intervals[c], :)) for r = 1:f.rblocks, c = 1:f.cblocks]

    # Redistribute histogram counts in accordance with the clip weight.
    map!(x-> (x[1], clip_histogram!(x[2], f.clip)), block_hist, block_hist)

    # Construct a CDF for each block in the image.
    block_cdf = [construct_cdf(block_hist[r,c]...) for r = 1:f.rblocks, c = 1:f.cblocks]

    block_centroid_r = [r * block_height - block_height ÷ 2 for r = 1:f.rblocks]
    block_centroid_c = [c * block_width - block_width ÷ 2 for c = 1:f.cblocks]
    intensity_range = (f.minval, f.maxval)
    # Transform pixels using linear and bilinear interpolation of the block CDFs.
    transform_image!(out_tmp, img_tmp, block_centroid_r, block_centroid_c,
                     block_width, block_height, intensity_range,
                     f.cblocks, f.rblocks, block_cdf)
    out .= must_resize ?  imresize(out_tmp, (height, width)) : out_tmp
    return out
end

function validate_parameters(f::AdaptiveEqualization)
    !(0 <= f.clip <= 1) && throw(ArgumentError("The parameter `clip` must be in the range [0..1]."))
    !(1 <= f.rblocks && 1 <= f.cblocks) && throw(ArgumentError("The parameters `rblocks` and `cblocks` must be greater than 0."))
end

function (f::AdaptiveEqualization)(out::AbstractArray{<:Color3}, img::AbstractArray{<:Color3})
    T = eltype(img)
    yiq = convert.(YIQ, img)
    yiq_view = channelview(yiq)
    #=
       TODO: Understand the cause and solution of this error.
       When I pass a view I run into this error on Julia 1.1.
       ERROR: ArgumentError: an array of type `Base.ReinterpretArray` shares memory with another argument and must
       make a preventative copy of itself in order to maintain consistent semantics,
       but `copy(A)` returns a new array of type `Array{Float64,3}`. To fix, implement:
       `Base.unaliascopy(A::Base.ReinterpretArray)::typeof(A)`
    =#
    #adjust_histogram!(view(yiq_view,1,:,:), f)
    y = comp1.(yiq)
    adjust_histogram!(y, f)
    yiq_view[1, :, :] .= y
    out .= convert.(T, yiq)
end



(f::AdaptiveEqualization)(out::GenericGrayImage, img::AbstractArray{<:Color3}) =
    f(out, of_eltype(Gray, img))

function clip_histogram!(histogram::AbstractArray, clip_weight::Number)
    limit, unfilled_bin_count = determine_threshold(histogram, clip_weight)
    initial_excess = determine_excess!(histogram, limit)
    remaining_excess = perform_initial_redistribution!(histogram, limit, initial_excess, unfilled_bin_count)
    perform_iterative_redistribution!(histogram, limit, remaining_excess)
    return histogram
end

function determine_excess!(histogram::AbstractArray, limit::Number)
    excess = zero(limit)
    for n in eachindex(histogram)
        val = histogram[n]
        if val > limit
            excess = excess + (val - limit)
            histogram[n] = limit
        end
    end
    return excess
end

function determine_threshold(histogram::AbstractArray, clip_weight::Number)
    sorted_hist = sort(collect(histogram), rev = true)
    required_capacity = zeros(axes(sorted_hist))
    available_capacity = zeros(axes(sorted_hist))
    # If we pick an empirical bin count as the actual limit, determine how many
    # counts we will need to move (required_capacity) and how much space do
    # we have in the bins (available_capacity).
    for i = 1:length(sorted_hist)
        required_capacity[i] = sum(sorted_hist[1:i] .- sorted_hist[i])
        available_capacity[i] = sum(sorted_hist[i] .- sorted_hist[i:end])
    end
    # Find the smallest feasible bin limit.
    largest_feasible_index = 1
    for i in eachindex(required_capacity)
        if available_capacity[i] < required_capacity[i]
            largest_feasible_index = i - 1
            break
        end
    end
    # The target bin limit is a convex combination of the highest bin count
    # and the smallest feasible bin count.
    smallest_feasible_limit = sorted_hist[largest_feasible_index]
    target_limit = (1 - clip_weight) * first(sorted_hist) + (clip_weight) * smallest_feasible_limit
    # Set the limit to be the empirical count that is close to the target limit.
    chosen_index = searchsortedlast(sorted_hist, round(Int,target_limit); rev = true)
    threshold = sorted_hist[chosen_index]
    # Knowing how many bins have spare capacity will help us distribute the
    # excess bin counts more efficiently in the perform_initial_redistribution!
    # function.
    unfilled_bin_count  = length(sorted_hist) - chosen_index
    return threshold, unfilled_bin_count
end

function perform_initial_redistribution!(histogram::AbstractArray, limit::Number, excess::Number, N::Integer)
    m = excess ÷ N
    for n in eachindex(histogram)
        val = histogram[n]
        if excess > 0
            if val < limit - m
                histogram[n] = histogram[n] + m
                excess = excess - m
            elseif val < limit
                excess = excess - (limit - val)
                histogram[n] = limit
            end
        end
    end
    return excess
end

function perform_iterative_redistribution!(histogram::AbstractArray, limit::Number, excess::Number)
    while excess > 0
        for n in eachindex(histogram)
            val = histogram[n]
            if excess > 0
                if val < limit
                    excess = excess - 1
                    histogram[n] = histogram[n]  + 1
                end
            end
        end
    end
end



function apply_cdf_transform(val::Union{Real,AbstractGray}, minval::Union{Real,AbstractGray}, maxval::Union{Real,AbstractGray}, edges::AbstractArray, cdf::AbstractArray)
    val, minval, maxval = intensity(val), intensity(minval), intensity(maxval)

    first_edge = first(edges)
    inv_step_size = 1 / step(edges)
    scale = (maxval - minval) / (cdf[end] - first(cdf))
    if val >= edges[end]
        newval = cdf[end]
    elseif val < first_edge
        newval = first(cdf)
    else
        index = floor(Int, (val - first_edge) * inv_step_size) + 1
        newval = cdf[index]
    end
    # Scale the new intensity value to so that it lies in the range [minval, maxval].
    newval = minval + (newval - first(cdf)) * scale
end

function transform_image!(out, img, block_centroid_r, block_centroid_c, block_width, block_height, intensity_range, cblocks, rblocks, block_cdf)
    height, width = length.(axes(out))
    r₀ = first(block_centroid_r) + 1
    r₁ = last(block_centroid_r) - 1
    c₀ = first(block_centroid_c) + 1
    c₁ = last(block_centroid_c) - 1
    block_dimensions = (block_width, block_height)

    # Interior
    bounds = (r₀:r₁, c₀:c₁)
    block_centroids = (block_centroid_r, block_centroid_c)
    transform_interior!(out, img, bounds, block_centroids, block_dimensions,
                        intensity_range, block_cdf)
    # West
    bounds = (r₀:r₁, 1:(c₀-1))
    block_c_idx = 1
    transform_vertical_strip!(out, img, bounds, block_centroid_r, block_c_idx,
                              block_height, intensity_range, block_cdf)
    # East
    bounds = (r₀:r₁, (c₁+1):width)
    block_c_idx = cblocks
    transform_vertical_strip!(out, img, bounds, block_centroid_r, block_c_idx,
                              block_height, intensity_range, block_cdf)
    # North
    bounds = (1:r₀-1, c₀:c₁)
    block_r_idx = 1
    transform_horizontal_strip!(out, img, bounds, block_centroid_c, block_r_idx,
                                block_width, intensity_range, block_cdf)
    # South
    bounds = (r₁+1:height, c₀:c₁)
    block_r_idx = rblocks
    transform_horizontal_strip!(out, img, bounds, block_centroid_c, block_r_idx,
                                block_width, intensity_range, block_cdf)
    # North-West
    bounds = (1:(r₀ - 1), 1:(c₀ - 1))
    block_r_idx = 1
    block_c_idx = 1
    transform_corner!(out, img, bounds, block_r_idx, block_c_idx,
                      intensity_range, block_cdf)
    # North-East
    bounds = (1:(r₀ - 1), (c₁ + 1):width)
    block_r_idx = 1
    block_c_idx = cblocks
    transform_corner!(out, img, bounds, block_r_idx, block_c_idx,
                      intensity_range, block_cdf)
    # South-West
    bounds = ((r₁ + 1):height, 1:(c₀ - 1))
    block_r_idx = rblocks
    block_c_idx = 1
    transform_corner!(out, img, bounds, block_r_idx , block_c_idx,
                      intensity_range, block_cdf)
    # South-East
    bounds = ((r₁ + 1):height, (c₁ + 1):width)
    block_r_idx = rblocks
    block_c_idx = cblocks
    transform_corner!(out, img, bounds, block_r_idx, block_c_idx,
                      intensity_range, block_cdf)
end

@inline integer_store(::Type{T}, x, lo, hi) where {T} = convert(T, clamp(ceil(x), lo, hi))
@inline clamp_store(::Type{T}, x, lo, hi)   where {T} = convert(T, clamp(x, lo, hi))

storefn(::Type{T}) where {T<:Integer} = integer_store
storefn(::Type{T}) where {T} = clamp_store

function transform_interior!(out::AbstractArray{T}, img, bounds, block_centroids, block_dimensions, intensity_range, block_cdf) where {T}
    rows, cols = bounds
    block_centroid_r, block_centroid_c = block_centroids
    block_width, block_height = block_dimensions
    minval, maxval = intensity_range

    lo = intensity(minval)
    hi = intensity(maxval)
    store = storefn(T)

    inv_block_height = 1 / block_height
    inv_block_width = 1 / block_width

    for r in rows
        for c in cols
            rᵢ = round(Int, r * inv_block_height)
            cᵢ = round(Int, c * inv_block_width)
            t = (r - block_centroid_r[rᵢ]) / block_height
            u = (c - block_centroid_c[cᵢ]) / block_width
            T₁ = apply_cdf_transform(img[r,c], minval, maxval, block_cdf[rᵢ, cᵢ]...)
            T₂ = apply_cdf_transform(img[r,c], minval, maxval, block_cdf[rᵢ + 1, cᵢ]...)
            T₃ = apply_cdf_transform(img[r,c], minval, maxval, block_cdf[rᵢ + 1, cᵢ + 1]...)
            T₄ = apply_cdf_transform(img[r,c], minval, maxval, block_cdf[rᵢ, cᵢ + 1]...)
            interpolated_val = (1 - t)*(1 - u)*T₁ + t*(1 - u)*T₂  + t*u*T₃ + (1 - t)*u*T₄
            out[r,c] = store(T, interpolated_val, lo, hi)
        end
    end
end


function transform_vertical_strip!(out::AbstractArray{T}, img, bounds, block_centroid_r, cᵢ, block_height, intensity_range, block_cdf) where {T}
    rows, cols = bounds
    minval, maxval = intensity_range

    lo = intensity(minval)
    hi = intensity(maxval)
    store = storefn(T)

    inv_block_height = 1 / block_height

    for r in rows
        for c in cols
            rᵢ = round(Int, r * inv_block_height)
            t = (r - block_centroid_r[rᵢ]) / block_height
            T₁ = apply_cdf_transform(img[r,c], minval, maxval, block_cdf[rᵢ, cᵢ]...)
            T₂ = apply_cdf_transform(img[r,c], minval, maxval, block_cdf[rᵢ + 1, cᵢ]...)
            interpolated_val = (1 - t)*T₁ + t*T₂
            out[r,c] = store(T, interpolated_val, lo, hi)
        end
    end
end


function transform_horizontal_strip!(out::AbstractArray{T}, img, bounds, block_centroid_c, rᵢ, block_width, intensity_range, block_cdf) where {T}
    rows, cols = bounds
    minval, maxval = intensity_range

    lo = intensity(minval)
    hi = intensity(maxval)
    store = storefn(T)

    inv_block_width = 1 / block_width

    for r in rows
        for c in cols
            cᵢ = round(Int, c * inv_block_width)
            u = (c - block_centroid_c[cᵢ]) / block_width
            T₁ = apply_cdf_transform(img[r,c], minval, maxval, block_cdf[rᵢ, cᵢ]...)
            T₂ = apply_cdf_transform(img[r,c], minval, maxval, block_cdf[rᵢ, cᵢ + 1]...)
            interpolated_val = (1 - u)*T₁ + u*T₂
            out[r,c] = store(T, interpolated_val, lo, hi)
        end
    end
end


function transform_corner!(out::AbstractArray{T}, img, bounds, rᵢ, cᵢ, intensity_range, block_cdf) where {T}
    rows, cols = bounds
    minval, maxval = intensity_range

    lo = intensity(minval)
    hi = intensity(maxval)
    store = storefn(T)

    for r in rows
        for c in cols
            val = apply_cdf_transform(img[r,c], minval, maxval, block_cdf[rᵢ, cᵢ]...)
            out[r,c] = store(T, val, lo, hi)
        end
    end
end

"""
```
    Matching <: AbstractHistogramAdjustmentAlgorithm
    Matching(targetimg; nbins = 256, edges = nothing)

    adjust_histogram([T,] img, f::Matching)
    adjust_histogram!([out,] img, f::Matching)
```

Returns a histogram matched image with a granularity of `nbins` number of bins.
The first argument `img` is the image to be matched, whereas the argument
`targetimg` in `Matching()` is the image having the desired histogram to be
matched to.

# Details
The purpose of histogram matching is to transform the intensities in a source
image so that the intensities distribute according to the histogram of a
specified target image. If one interprets histograms as piecewise-constant
models of probability density functions (see [`build_histogram`](@ref
build_histogram(::AbstractArray, ::Integer, ::Union{Real,AbstractGray},
::Union{Real,AbstractGray}))), then the histogram matching task can be modelled
as the problem of transforming one probability distribution into another [1].
It turns out that the solution to this transformation problem involves the
cumulative and inverse cumulative distribution functions of the source and
target probability density functions.

In particular, let the random variables ``x \\thicksim p_{x} `` and ``z
\\thicksim p_{z}``  represent an intensity in the source and target image
respectively, and let

```math
 S(x) = \\int_0^{x}p_{x}(w)\\mathrm{d} w \\quad \\text{and} \\quad
 T(z) = \\int_0^{z}p_{z}(w)\\mathrm{d} w
```
represent their concomitant cumulative distribution functions. Then the
sought-after mapping ``Q(\\cdot)`` such that ``Q(x) \\thicksim p_{z} `` is given
by

```math
Q(x) =  T^{-1}\\left( S(x) \\right),
```

where ``T^{-1}(y) = \\operatorname{min} \\{ x \\in \\mathbb{R} : y \\leq T(x)
\\}`` is the inverse cumulative distribution function of ``T(x)``.

The mapping suggests that one can conceptualize histogram matching as performing
histogram equalization on the source and target image and relating the two
equalized histograms. Refer to [`adjust_histogram`](@ref
adjust_histogram(::Equalization, ::AbstractArray, ::Integer,
::Union{Real,AbstractGray}, ::Union{Real,AbstractGray})) for more details on
histogram equalization.

# Options

Various options for the parameters of the `adjust_histogram` function and `Matching`
type are described in more detail below.

## Choices for `img` and `targetimg`

The `adjust_histogram(img, Matching())` function can handle a variety of input
types. The type of the returned image matches the input type.

For colored images, the inputs are converted to
[YIQ](https://en.wikipedia.org/wiki/YIQ)  type and the distributions of the Y
channels are matched. The modified Y channel is then combined with the I and Q
channels and the resulting image converted to the same type as the input.

## Choices for `nbins`

You can specify the total number of bins in the histogram. If you do not
specify the number of bins then a default value of 256 bins is utilized.

## Choices for `edges`

If you do not designate the number of bins, then you have the option to directly
stipulate how the intervals will be divided by specifying a `AbstractRange`
type.

# Example

```julia
using Images, TestImages, ImageView

img_source = testimage("mandril_gray")
img_target = adjust_histogram(img_source, GammaCorrection(gamma = 0.5))
img_transformed = adjust_histogram(img_source, Matching(targetimg = img_target))
#=
    A visual inspection confirms that img_transformed resembles img_target
    much more closely than img_source.
=#
imshow(img_source)
imshow(img_target)
imshow(img_transformed)
```

# References
1. W. Burger and M. J. Burge. *Digital Image Processing*. Texts in Computer Science, 2016. [doi:10.1007/978-1-4471-6684-9](https://doi.org/10.1007/978-1-4471-6684-9)
"""
@with_kw struct Matching{T₁ <: AbstractArray,
                            T₂ <: Union{Integer, Nothing},
                            T₃ <: Union{AbstractRange, Nothing}} <: AbstractHistogramAdjustmentAlgorithm
    targetimg::T₁
    nbins::T₂ = 256
    edges::T₃ = nothing
end

function (f::Matching)(out::GenericGrayImage, img::GenericGrayImage)
    #TODO Throw error/warning if user specifies both edges and nbins simultaneously.
    out .= img
    edges, pdf, target_pdf = isnothing(f.edges) ? construct_pdfs(out, f.targetimg, f.nbins) : construct_pdfs(out, f.targetimg, f.edges)
    match_pdf!(out, edges, pdf, target_pdf)
    return out
end

function (f::Matching)(out::AbstractArray{<:Color3}, img::AbstractArray{<:Color3})
    T = eltype(img)
    yiq = convert.(YIQ, img)
    yiq_view = channelview(yiq)

    targetimg = f.targetimg
    yiq_targetimg = convert.(YIQ, targetimg)
    yiq_targetimg_view = channelview(yiq_targetimg)

    adjust_histogram!(view(yiq_view,1,:,:), Matching(targetimg = view(yiq_targetimg_view,1,:,:),
                                                         edges = f.edges,
                                                         nbins = f.nbins))
    out .= convert.(T, yiq)
end

(f::Matching)(out::GenericGrayImage, img::AbstractArray{<:Color3}) =
    f(out, of_eltype(Gray, img))


function match_pdf!(img::GenericGrayImage, edges::AbstractArray, pdf::AbstractArray, target_pdf::AbstractArray)
    cdf = parent(cumsum(pdf))
    target_cdf = parent(cumsum(target_pdf))
    # Precompute the inverse cummulative distribution function of target_cdf.
    lookup_table = lookup_icdf(cdf, target_cdf)
    # Transform the intensities in img so that they are distributed according
    # to the distribution of the target_histogram.
    T = eltype(img)
    step_size = step(edges)
    first_edge = first(edges)
    last_edge = last(edges)
    map!(img, img) do val
        val = intensity(val)
        if isnan(val)
            return val
        else
            if val >= last_edge
                newval = edges[last(lookup_table)-1] + step_size
            elseif val < first_edge
                newval = edges[first(lookup_table)]
            else
                index = Int(Base.div(val-first_edge,step_size)) + 1
                newval = edges[lookup_table[index]]
            end
            return T <: Integer ? ceil(newval) : newval
        end
    end
end

@testset "Histogram Construction" begin
    # Consider an image where each intensity occurs only once and vary the number
    # of bins used in the histogram in powers of two. With the exception of the
    # first bin (with index 0), all other bins should have equal counts.
    expected_counts = [2^i for i = 0:7]
    bins = [2^i for i = 8:-1:1]
    for i = 1:length(bins)
        for T in (Gray{N0f8}, Gray{N0f16}, Gray{Float32}, Gray{Float64})
            edges, counts  = build_histogram(T.(collect(0:1/255:1)),bins[i], minval = 0, maxval = 1)
            @test length(edges) == length(counts) - 1
            @test all(counts[1:end] .== expected_counts[i]) && counts[0] == 0
            @test axes(counts) == (0:length(edges),)
        end

        # Verify that the function can also take a color image as an input.
        for T in (RGB{N0f8}, RGB{N0f16}, RGB{Float32}, RGB{Float64})
            imgg = collect(0:1/255:1)
            img = colorview(RGB,imgg,imgg,imgg)
            edges, counts  = build_histogram(T.(img),bins[i], minval = 0, maxval = 1)
            @test length(edges) == length(counts) - 1
            @test all(counts[1:end] .== expected_counts[i]) && counts[0] == 0
            @test axes(counts) == (0:length(edges),)
        end

        # Consider also integer-valued images.
        edges, counts  = build_histogram(0:1:255,bins[i], minval = 0, maxval = 255)
        @test length(edges) == length(counts) - 1
        @test all(counts[1:end] .== expected_counts[i]) && counts[0] == 0
        @test axes(counts) == (0:length(edges),)
    end

    # Consider truncated intervals.
    for T in (Int, Gray{N0f8}, Gray{N0f16}, Gray{Float32}, Gray{Float64})
        if T == Int
            edges, counts  = build_histogram(0:1:255,4, minval = 128, maxval = 192)
            @test length(edges) == length(counts) - 1
            @test collect(counts) == [128; 16; 16; 16; 80]
            @test axes(counts) == (0:length(edges),)
        else
            img = collect(0:1/255:1)
            edges, counts  = build_histogram(T.(img),4, minval = 128/255, maxval = 192/255)
            @test length(edges) == length(counts) - 1
            @test collect(counts) == [128; 16; 16; 16; 80]
            @test axes(counts) == (0:length(edges),)
        end

        if T == Int
            edges, counts  = build_histogram(0:1:255,4, minval = 120,maxval = 140)
            @test length(edges) == length(counts) - 1
            @test collect(counts) == [120, 5, 5, 5, 121]
            @test axes(counts) == (0:length(edges),)
        else
            img = collect(0:1/255:1)
            edges, counts  = build_histogram(T.(img),4,minval = 120/255, maxval = 140/255)
            @test length(edges) == length(counts) - 1
            @test axes(counts) == (0:length(edges),)
            # Due to roundoff errors the bins are not the same as in the
            # integer case above.
            @test all([120, 4, 4, 4, 121] .<= collect(counts) .<= [120, 6, 6, 6, 121])
            @test sum(counts) == length(img)
        end
    end

    # Consider the case where the minimum and maximum values are not the start and
    # end points of the dynamic range. Because of numerical precision, the
    # results will be slightly different depending on the Image type.
    for T in (Int, Gray{N0f8}, Gray{N0f16}, Gray{Float32}, Gray{Float64})
        if T == Int
            edges, counts  = build_histogram(200:1:240,4, minval = 200, maxval = 240)

            @test length(edges) == length(counts) - 1
            @test collect(counts) == [0, 10, 10, 10, 11]
            @test axes(counts) == (0:length(edges),)

            edges, counts  = build_histogram(200:1:240,4)
            @test length(edges) == length(counts) - 1
            @test collect(counts) == [0, 10, 10, 10, 11]
            @test axes(counts) == (0:length(edges),)
        else
            img = 200/255:1/255:240/255
            edges, counts  = build_histogram(T.(img),4, minval = 200/255, maxval = 240/255)
            @test length(edges) == length(counts) - 1
            @test all([0, 9, 9, 9, 11] .<= collect(counts) .<= [0, 11, 11, 11, 11])
            @test sum(counts) == length(img)
            @test axes(counts) == (0:length(edges),)

            edges, counts  = build_histogram(T.(img),4)
            @test axes(counts) == (0:length(edges),)
            @test length(edges) == length(counts) - 1
            @test all([0, 9, 9, 9, 10] .<= collect(counts) .<= [0, 11, 11, 11, 11])
            @test sum(counts) == length(img)
        end
    end

    # Consider the effect of NaN on the histogram counts.
    for j = 2:255
        for T in (Gray{Float32}, Gray{Float64})
            img = collect(0:1/255:1)
            img[j] = NaN
            edges, counts  = build_histogram(T.(img),256, minval = 0, maxval = 1)
            target = [1 for k = 1:length(counts)-1]
            target[j] -= 1
            @test length(edges) == length(counts) - 1
            @test counts[1:end] == target && counts[0] == 0
            @test axes(counts) == (0:length(edges),)

            # Verify that the minimum value (0) and maximum value (1) is
            # determined automatically even when there are NaN values
            # between these two bounds.
            img = collect(0:1/255:1)
            img[j] = NaN
            edges, counts  = build_histogram(T.(img),256)
            target = [1 for k = 1:length(counts)-1]
            target[j] -= 1 # Because of the NaN value in the image
            @test length(edges) == length(counts) - 1
            @test counts[1:end] == target && counts[0] == 0
            @test axes(counts) == (0:length(edges),)
        end
    end
end

using Documenter, ImageContrastAdjustment
makedocs(sitename="Documentation",
            format = Documenter.HTML(prettyurls = get(ENV, "CI", nothing) == "true"))
deploydocs(repo = "github.com/JuliaImages/ImageContrastAdjustment.jl.git")

# [Function References](@id function_reference)

```@contents
Pages = ["reference.md"]
Depth = 3
```

## General function

```@docs
adjust_histogram
adjust_histogram!
build_histogram
```

## Algorithms

```@docs
ImageContrastAdjustment.HistogramAdjustmentAPI.AbstractHistogramAdjustmentAlgorithm
```

### AdaptiveEqualization
```@docs
AdaptiveEqualization
```

### ContrastStretching
```@docs
ContrastStretching
```

### Equalization
```@docs
Equalization
```

### LinearStretching
```@docs
LinearStretching
```

### Matching
```@docs
Matching
```

### MidwayEqualization
```@docs
MidwayEqualization
```

# ImageContrastAdjustment.jl Documentation

A Julia package for enhancing and manipulating image contrast.

```@contents
Depth = 3
```

## Getting started
This package is part of a wider Julia-based image processing
[ecosystem](https://github.com/JuliaImages). If you are starting out, then you
may benefit from [reading](https://juliaimages.org/latest/quickstart/) about
some fundamental conventions that the ecosystem utilizes that are markedly
different from how images are typically represented in OpenCV, MATLAB, ImageJ or
Python.

The usage examples in the `ImageContrastAdjustment.jl` package assume that you have
already installed some key packages. Notably, the examples assume that you are
able to load and display an image. Loading an image is facilitated through the
[FileIO.jl](https://github.com/JuliaIO/FileIO.jl) package, which uses
[QuartzImageIO.jl](https://github.com/JuliaIO/QuartzImageIO.jl) if you are on
`MacOS`, and [ImageMagick.jl](https://github.com/JuliaIO/ImageMagick.jl)
otherwise. Depending on your particular system configuration, you might
encounter problems installing the image loading packages, in which case you can
refer to the [troubleshooting
guide](https://juliaimages.org/latest/troubleshooting/#Installation-troubleshooting-1).

Image display is typically handled by the
[ImageView.jl](https://github.com/JuliaImages/ImageView.jl) package. 
Alternatives include the various plotting packages, including
[Makie.jl](https://github.com/JuliaPlots/Makie.jl). There is
also the [ImageShow.jl](https://github.com/JuliaImages/ImageShow.jl) package
which facilitates displaying images in `Jupyter` notebooks via
[IJulia.jl](https://github.com/JuliaLang/IJulia.jl).
Finally, one can also obtain a useful preview of an image in the REPL using the
[ImageInTerminal.jl](https://github.com/JuliaImages/ImageInTerminal.jl) package.
However, this package assumes that the terminal uses a monospace font, and tends
not to produce adequate results in a Windows environment.

Another package that is used to illustrate the functionality in
`ImageContrastAdjustment.jl` is the
[TestImages.jl](https://github.com/JuliaImages/TestImages.jl) which serves as a
repository of many standard image processing test images.


## Basic usage

Each contrast manipulation algorithm in `ImageContrastAdjustment.jl` is an
[`AbstractHistogramAdjustmentAlgorithm`](@ref
ImageContrastAdjustment.HistogramAdjustmentAPI.AbstractHistogramAdjustmentAlgorithm).

Suppose one wants to enhance the contrast an image. This can be achieved by
simply choosing an appropriate algorithm and calling [`adjust_histogram`](@ref)
or [`adjust_histogram!`](@ref) in the image. The contrast will be automatically
enhanced.

Let's see a simple demo:

```@example
using TestImages, ImageContrastAdjustment
using FileIO # hide
img = testimage("cameraman")
alg = Equalization(nbins = 256)
img_adjusted = adjust_histogram(img, alg)
save("images/demo.jpg", hcat(img, img_adjusted)) # hide
```

```@raw html
<img src="images/demo.jpg" width="400px" alt="demo image" />
```

This usage reads as "`adjust_histogram` of the image `img` with algorithm `alg`"

For more advanced usage, please check [function reference](@ref function_reference) page.

## Examples
Below are some examples of contrast adjustment operations that this package facilitates.

```@raw html
<table width="500" border="0" cellpadding="5">

<tr>

<td align="center" valign="center">
<img src="images/contrast_stretching.gif" width="100px" alt="Contrast Stretching" />
<br />
Contrast Stretching
</td>

<td align="center" valign="center">
<img src="images/contrast_stretching_col.gif" width="100px" alt="Contrast Stretching" />
<br />
Contrast Stretching
</td>

</tr>

<tr>

<td align="center" valign="center">
<img src="images/linear_stretching.gif" width="100px" alt="Linear Stretching (Normalization)" />
<br />
Linear Stretching/Normalization
</td>

<td align="center" valign="center">
<img src="images/linear_stretching_col.gif" width="100px" alt="Linear Stretching (Normalization)" />
<br />
Linear Stretching/Normalization
</td>

</tr>

<tr>

<td align="center" valign="center">
<img src="images/gamma_correction.gif" width="100px" alt="Gamma Correction" />
<br />
Gamma Correction
</td>

<td align="center" valign="center">
<img src="images/gamma_correction_col.gif" width="100px" alt="Gamma Correction" />
<br />
Gamma Correction
</td>

</tr>

<tr>

<td align="center" valign="center">
<img src="images/equalization.gif" width="100px" alt="Histogram Equalization" />
<br />
Histogram Equalization
</td>

<td align="center" valign="center">
<img src="images/equalization_col.gif" width="100px" alt="Histogram Equalization" />
<br />
Histogram Equalization
</td>

</tr>

<tr>

<td align="center" valign="center">
<img src="images/adaptive_equalization.gif" width="100px" alt="Contrast Limited Adaptive Histogram Equalization" />
<br />
Contrast Limited Adaptive Histogram Equalization
</td>

<td align="center" valign="center">
<img src="images/adaptive_equalization_col.gif" width="100px" alt="Contrast Limited Adaptive Histogram Equalization" />
<br />
Contrast Limited Adaptive Histogram Equalization
</td>

</tr>

<tr>

<td align="center" valign="center">
<img src="images/midway_equalization.gif" width="100px" alt="Midway Histogram Equalization" />
<br />
Midway Histogram Equalization
</td>

<td align="center" valign="center">
<img src="images/midway_equalization_col.gif" width="100px" alt="Midway Histogram Equalization" />
<br />
Midway Histogram Equalization
</td>

</tr>

<tr>

<td align="center" valign="center">
<img src="images/matching.gif" width="100px" alt="Histogram Matching" />
<br />
Histogram Matching
</td>

<td align="center" valign="center">
<img src="images/matching_col.gif" width="100px" alt="Histogram Matching" />
<br />
Histogram Matching
</td>

</tr>

</table>
```
